diff --git a/Makefile.am b/Makefile.am
index 83714cb..3180732 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -2,7 +2,7 @@
 
 ACLOCAL_AMFLAGS = -I config
 
-SUBDIRS = config src templates doc hooks
+SUBDIRS = config src templates doc hooks lcrso
 DIST_SUBDIRS = config src templates doc hooks
 EXTRA_DIST = \
 	autogen.sh \
diff --git a/Makefile.in b/Makefile.in
index 54c7024..39f5a2c 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -394,7 +394,7 @@ top_build_prefix = @top_build_prefix@
 top_builddir = @top_builddir@
 top_srcdir = @top_srcdir@
 ACLOCAL_AMFLAGS = -I config
-SUBDIRS = config src templates doc hooks
+SUBDIRS = config src templates doc hooks lcrso
 DIST_SUBDIRS = config src templates doc hooks
 EXTRA_DIST = \
 	autogen.sh \
@@ -661,16 +661,10 @@ dist-xz: distdir
 	$(am__post_remove_distdir)
 
 dist-tarZ: distdir
-	@echo WARNING: "Support for shar distribution archives is" \
-	               "deprecated." >&2
-	@echo WARNING: "It will be removed altogether in Automake 2.0" >&2
 	tardir=$(distdir) && $(am__tar) | compress -c >$(distdir).tar.Z
 	$(am__post_remove_distdir)
 
 dist-shar: distdir
-	@echo WARNING: "Support for distribution archives compressed with" \
-		       "legacy program 'compress' is deprecated." >&2
-	@echo WARNING: "It will be removed altogether in Automake 2.0" >&2
 	shar $(distdir) | GZIP=$(GZIP_ENV) gzip -c >$(distdir).shar.gz
 	$(am__post_remove_distdir)
 
@@ -712,10 +706,9 @@ distcheck: dist
 	  && dc_destdir="$${TMPDIR-/tmp}/am-dc-$$$$/" \
 	  && am__cwd=`pwd` \
 	  && $(am__cd) $(distdir)/_build \
-	  && ../configure \
+	  && ../configure --srcdir=.. --prefix="$$dc_install_base" \
 	    $(AM_DISTCHECK_CONFIGURE_FLAGS) \
 	    $(DISTCHECK_CONFIGURE_FLAGS) \
-	    --srcdir=.. --prefix="$$dc_install_base" \
 	  && $(MAKE) $(AM_MAKEFLAGS) \
 	  && $(MAKE) $(AM_MAKEFLAGS) dvi \
 	  && $(MAKE) $(AM_MAKEFLAGS) check \
diff --git a/aclocal.m4 b/aclocal.m4
index 8e31bb3..89c6141 100644
--- a/aclocal.m4
+++ b/aclocal.m4
@@ -1,4 +1,4 @@
-# generated automatically by aclocal 1.14.1 -*- Autoconf -*-
+# generated automatically by aclocal 1.13.4 -*- Autoconf -*-
 
 # Copyright (C) 1996-2013 Free Software Foundation, Inc.
 
@@ -180,6 +180,46 @@ else
 fi[]dnl
 ])# PKG_CHECK_MODULES
 
+
+# PKG_INSTALLDIR(DIRECTORY)
+# -------------------------
+# Substitutes the variable pkgconfigdir as the location where a module
+# should install pkg-config .pc files. By default the directory is
+# $libdir/pkgconfig, but the default can be changed by passing
+# DIRECTORY. The user can override through the --with-pkgconfigdir
+# parameter.
+AC_DEFUN([PKG_INSTALLDIR],
+[m4_pushdef([pkg_default], [m4_default([$1], ['${libdir}/pkgconfig'])])
+m4_pushdef([pkg_description],
+    [pkg-config installation directory @<:@]pkg_default[@:>@])
+AC_ARG_WITH([pkgconfigdir],
+    [AS_HELP_STRING([--with-pkgconfigdir], pkg_description)],,
+    [with_pkgconfigdir=]pkg_default)
+AC_SUBST([pkgconfigdir], [$with_pkgconfigdir])
+m4_popdef([pkg_default])
+m4_popdef([pkg_description])
+]) dnl PKG_INSTALLDIR
+
+
+# PKG_NOARCH_INSTALLDIR(DIRECTORY)
+# -------------------------
+# Substitutes the variable noarch_pkgconfigdir as the location where a
+# module should install arch-independent pkg-config .pc files. By
+# default the directory is $datadir/pkgconfig, but the default can be
+# changed by passing DIRECTORY. The user can override through the
+# --with-noarch-pkgconfigdir parameter.
+AC_DEFUN([PKG_NOARCH_INSTALLDIR],
+[m4_pushdef([pkg_default], [m4_default([$1], ['${datadir}/pkgconfig'])])
+m4_pushdef([pkg_description],
+    [pkg-config arch-independent installation directory @<:@]pkg_default[@:>@])
+AC_ARG_WITH([noarch-pkgconfigdir],
+    [AS_HELP_STRING([--with-noarch-pkgconfigdir], pkg_description)],,
+    [with_noarch_pkgconfigdir=]pkg_default)
+AC_SUBST([noarch_pkgconfigdir], [$with_noarch_pkgconfigdir])
+m4_popdef([pkg_default])
+m4_popdef([pkg_description])
+]) dnl PKG_NOARCH_INSTALLDIR
+
 # Copyright (C) 2002-2013 Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
@@ -192,10 +232,10 @@ fi[]dnl
 # generated from the m4 files accompanying Automake X.Y.
 # (This private macro should not be called outside this file.)
 AC_DEFUN([AM_AUTOMAKE_VERSION],
-[am__api_version='1.14'
+[am__api_version='1.13'
 dnl Some users find AM_AUTOMAKE_VERSION and mistake it for a way to
 dnl require some minimum version.  Point them to the right macro.
-m4_if([$1], [1.14.1], [],
+m4_if([$1], [1.13.4], [],
       [AC_FATAL([Do not call $0, use AM_INIT_AUTOMAKE([$1]).])])dnl
 ])
 
@@ -211,7 +251,7 @@ m4_define([_AM_AUTOCONF_VERSION], [])
 # Call AM_AUTOMAKE_VERSION and AM_AUTOMAKE_VERSION so they can be traced.
 # This function is AC_REQUIREd by AM_INIT_AUTOMAKE.
 AC_DEFUN([AM_SET_CURRENT_AUTOMAKE_VERSION],
-[AM_AUTOMAKE_VERSION([1.14.1])dnl
+[AM_AUTOMAKE_VERSION([1.13.4])dnl
 m4_ifndef([AC_AUTOCONF_VERSION],
   [m4_copy([m4_PACKAGE_VERSION], [AC_AUTOCONF_VERSION])])dnl
 _AM_AUTOCONF_VERSION(m4_defn([AC_AUTOCONF_VERSION]))])
@@ -615,12 +655,6 @@ AC_DEFUN([AM_OUTPUT_DEPENDENCY_COMMANDS],
 # This macro actually does too much.  Some checks are only needed if
 # your package does certain things.  But this isn't really a big deal.
 
-dnl Redefine AC_PROG_CC to automatically invoke _AM_PROG_CC_C_O.
-m4_define([AC_PROG_CC],
-m4_defn([AC_PROG_CC])
-[_AM_PROG_CC_C_O
-])
-
 # AM_INIT_AUTOMAKE(PACKAGE, VERSION, [NO-DEFINE])
 # AM_INIT_AUTOMAKE([OPTIONS])
 # -----------------------------------------------
@@ -729,48 +763,7 @@ dnl macro is hooked onto _AC_COMPILER_EXEEXT early, see below.
 AC_CONFIG_COMMANDS_PRE(dnl
 [m4_provide_if([_AM_COMPILER_EXEEXT],
   [AM_CONDITIONAL([am__EXEEXT], [test -n "$EXEEXT"])])])dnl
-
-# POSIX will say in a future version that running "rm -f" with no argument
-# is OK; and we want to be able to make that assumption in our Makefile
-# recipes.  So use an aggressive probe to check that the usage we want is
-# actually supported "in the wild" to an acceptable degree.
-# See automake bug#10828.
-# To make any issue more visible, cause the running configure to be aborted
-# by default if the 'rm' program in use doesn't match our expectations; the
-# user can still override this though.
-if rm -f && rm -fr && rm -rf; then : OK; else
-  cat >&2 <<'END'
-Oops!
-
-Your 'rm' program seems unable to run without file operands specified
-on the command line, even when the '-f' option is present.  This is contrary
-to the behaviour of most rm programs out there, and not conforming with
-the upcoming POSIX standard: <http://austingroupbugs.net/view.php?id=542>
-
-Please tell bug-automake@gnu.org about your system, including the value
-of your $PATH and any error possibly output before this message.  This
-can help us improve future automake versions.
-
-END
-  if test x"$ACCEPT_INFERIOR_RM_PROGRAM" = x"yes"; then
-    echo 'Configuration will proceed anyway, since you have set the' >&2
-    echo 'ACCEPT_INFERIOR_RM_PROGRAM variable to "yes"' >&2
-    echo >&2
-  else
-    cat >&2 <<'END'
-Aborting the configuration process, to ensure you take notice of the issue.
-
-You can download and install GNU coreutils to get an 'rm' implementation
-that behaves properly: <http://www.gnu.org/software/coreutils/>.
-
-If you want to complete the configuration process using your problematic
-'rm' anyway, export the environment variable ACCEPT_INFERIOR_RM_PROGRAM
-to "yes", and re-run configure.
-
-END
-    AC_MSG_ERROR([Your 'rm' program is bad, sorry.])
-  fi
-fi])
+])
 
 dnl Hook into '_AC_COMPILER_EXEEXT' early to learn its expansion.  Do not
 dnl add the conditional right here, as _AC_COMPILER_EXEEXT may be further
@@ -778,6 +771,7 @@ dnl mangled by Autoconf and run in a shell conditional statement.
 m4_define([_AC_COMPILER_EXEEXT],
 m4_defn([_AC_COMPILER_EXEEXT])[m4_provide([_AM_COMPILER_EXEEXT])])
 
+
 # When config.status generates a header, we must update the stamp-h file.
 # This file resides in the same directory as the config header
 # that is generated.  The stamp files are numbered to have different names.
@@ -889,6 +883,38 @@ AC_MSG_RESULT([$_am_result])
 rm -f confinc confmf
 ])
 
+# Copyright (C) 1999-2013 Free Software Foundation, Inc.
+#
+# This file is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# AM_PROG_CC_C_O
+# --------------
+# Like AC_PROG_CC_C_O, but changed for automake.
+AC_DEFUN([AM_PROG_CC_C_O],
+[AC_REQUIRE([AC_PROG_CC_C_O])dnl
+AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
+AC_REQUIRE_AUX_FILE([compile])dnl
+# FIXME: we rely on the cache variable name because
+# there is no other way.
+set dummy $CC
+am_cc=`echo $[2] | sed ['s/[^a-zA-Z0-9_]/_/g;s/^[0-9]/_/']`
+eval am_t=\$ac_cv_prog_cc_${am_cc}_c_o
+if test "$am_t" != yes; then
+   # Losing compiler, so override with the script.
+   # FIXME: It is wrong to rewrite CC.
+   # But if we don't then we get into trouble of one sort or another.
+   # A longer-term fix would be to have automake use am__CC in this case,
+   # and then we could set am__CC="\$(top_srcdir)/compile \$(CC)"
+   CC="$am_aux_dir/compile $CC"
+fi
+dnl Make sure AC_PROG_CC is never called again, or it will override our
+dnl setting of CC.
+m4_define([AC_PROG_CC],
+          [m4_fatal([AC_PROG_CC cannot be called after AM_PROG_CC_C_O])])
+])
+
 # Fake the existence of programs that GNU maintainers use.  -*- Autoconf -*-
 
 # Copyright (C) 1997-2013 Free Software Foundation, Inc.
@@ -965,53 +991,6 @@ AC_DEFUN([_AM_IF_OPTION],
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# _AM_PROG_CC_C_O
-# ---------------
-# Like AC_PROG_CC_C_O, but changed for automake.  We rewrite AC_PROG_CC
-# to automatically call this.
-AC_DEFUN([_AM_PROG_CC_C_O],
-[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
-AC_REQUIRE_AUX_FILE([compile])dnl
-AC_LANG_PUSH([C])dnl
-AC_CACHE_CHECK(
-  [whether $CC understands -c and -o together],
-  [am_cv_prog_cc_c_o],
-  [AC_LANG_CONFTEST([AC_LANG_PROGRAM([])])
-  # Make sure it works both with $CC and with simple cc.
-  # Following AC_PROG_CC_C_O, we do the test twice because some
-  # compilers refuse to overwrite an existing .o file with -o,
-  # though they will create one.
-  am_cv_prog_cc_c_o=yes
-  for am_i in 1 2; do
-    if AM_RUN_LOG([$CC -c conftest.$ac_ext -o conftest2.$ac_objext]) \
-         && test -f conftest2.$ac_objext; then
-      : OK
-    else
-      am_cv_prog_cc_c_o=no
-      break
-    fi
-  done
-  rm -f core conftest*
-  unset am_i])
-if test "$am_cv_prog_cc_c_o" != yes; then
-   # Losing compiler, so override with the script.
-   # FIXME: It is wrong to rewrite CC.
-   # But if we don't then we get into trouble of one sort or another.
-   # A longer-term fix would be to have automake use am__CC in this case,
-   # and then we could set am__CC="\$(top_srcdir)/compile \$(CC)"
-   CC="$am_aux_dir/compile $CC"
-fi
-AC_LANG_POP([C])])
-
-# For backward compatibility.
-AC_DEFUN_ONCE([AM_PROG_CC_C_O], [AC_REQUIRE([AC_PROG_CC])])
-
-# Copyright (C) 1999-2013 Free Software Foundation, Inc.
-#
-# This file is free software; the Free Software Foundation
-# gives unlimited permission to copy and/or distribute it,
-# with or without modifications, as long as this notice is preserved.
-
 
 # AM_PATH_PYTHON([MINIMUM-VERSION], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
 # ---------------------------------------------------------------------------
diff --git a/config/Makefile.in b/config/Makefile.in
index 4f2beec..9394843 100644
--- a/config/Makefile.in
+++ b/config/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -79,7 +79,7 @@ build_triplet = @build@
 host_triplet = @host@
 subdir = config
 DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.am compile \
-	config.guess config.sub install-sh missing
+	config.guess config.sub depcomp install-sh missing
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 am__aclocal_m4_deps = $(top_srcdir)/config/acinclude.m4 \
 	$(top_srcdir)/config/tls.m4 $(top_srcdir)/configure.ac
diff --git a/config/apparmor/Makefile.in b/config/apparmor/Makefile.in
index 9bb2802..4f1bf06 100644
--- a/config/apparmor/Makefile.in
+++ b/config/apparmor/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -388,8 +388,8 @@ distclean-generic:
 maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
 	@echo "it deletes files that may require special tools to rebuild."
-@ENABLE_APPARMOR_FALSE@install-data-local:
 @ENABLE_APPARMOR_FALSE@uninstall-local:
+@ENABLE_APPARMOR_FALSE@install-data-local:
 clean: clean-am
 
 clean-am: clean-generic mostlyclean-am
diff --git a/config/bash/Makefile.in b/config/bash/Makefile.in
index bce26f1..8eb1aec 100644
--- a/config/bash/Makefile.in
+++ b/config/bash/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/config/etc/Makefile.in b/config/etc/Makefile.in
index a5f19f6..7cc13b7 100644
--- a/config/etc/Makefile.in
+++ b/config/etc/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/config/init/Makefile.in b/config/init/Makefile.in
index 14f76b5..f19b706 100644
--- a/config/init/Makefile.in
+++ b/config/init/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/config/init/systemd/Makefile.in b/config/init/systemd/Makefile.in
index 2de5144..2329741 100644
--- a/config/init/systemd/Makefile.in
+++ b/config/init/systemd/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -457,8 +457,8 @@ maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
 	@echo "it deletes files that may require special tools to rebuild."
 	-test -z "$(BUILT_SOURCES)" || rm -f $(BUILT_SOURCES)
-@INIT_SCRIPT_SYSTEMD_FALSE@install-data-local:
 @INIT_SCRIPT_SYSTEMD_FALSE@uninstall-local:
+@INIT_SCRIPT_SYSTEMD_FALSE@install-data-local:
 clean: clean-am
 
 clean-am: clean-generic mostlyclean-am
diff --git a/config/init/sysvinit/Makefile.in b/config/init/sysvinit/Makefile.in
index 499cfa3..ba71453 100644
--- a/config/init/sysvinit/Makefile.in
+++ b/config/init/sysvinit/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/config/init/upstart/Makefile.in b/config/init/upstart/Makefile.in
index 4cb4236..8be9bf4 100644
--- a/config/init/upstart/Makefile.in
+++ b/config/init/upstart/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -376,8 +376,8 @@ distclean-generic:
 maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
 	@echo "it deletes files that may require special tools to rebuild."
-@INIT_SCRIPT_UPSTART_FALSE@install-data-local:
 @INIT_SCRIPT_UPSTART_FALSE@uninstall-local:
+@INIT_SCRIPT_UPSTART_FALSE@install-data-local:
 clean: clean-am
 
 clean-am: clean-generic mostlyclean-am
diff --git a/config/templates/Makefile.in b/config/templates/Makefile.in
index 845ecc9..78741bb 100644
--- a/config/templates/Makefile.in
+++ b/config/templates/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/config/yum/Makefile.in b/config/yum/Makefile.in
index 49e60f5..d9c3f1a 100644
--- a/config/yum/Makefile.in
+++ b/config/yum/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/configure b/configure
index 85804ba..3191565 100755
--- a/configure
+++ b/configure
@@ -2640,7 +2640,7 @@ ac_configure="$SHELL $ac_aux_dir/configure"  # Please don't use this var.
 
 ac_config_headers="$ac_config_headers src/config.h"
 
-am__api_version='1.14'
+am__api_version='1.13'
 
 # Find a good install program.  We prefer a C program (faster),
 # so one script is as good as another.  But avoid the broken or
@@ -3177,47 +3177,6 @@ am__tar='$${TAR-tar} chof - "$$tardir"' am__untar='$${TAR-tar} xf -'
 
 
 
-# POSIX will say in a future version that running "rm -f" with no argument
-# is OK; and we want to be able to make that assumption in our Makefile
-# recipes.  So use an aggressive probe to check that the usage we want is
-# actually supported "in the wild" to an acceptable degree.
-# See automake bug#10828.
-# To make any issue more visible, cause the running configure to be aborted
-# by default if the 'rm' program in use doesn't match our expectations; the
-# user can still override this though.
-if rm -f && rm -fr && rm -rf; then : OK; else
-  cat >&2 <<'END'
-Oops!
-
-Your 'rm' program seems unable to run without file operands specified
-on the command line, even when the '-f' option is present.  This is contrary
-to the behaviour of most rm programs out there, and not conforming with
-the upcoming POSIX standard: <http://austingroupbugs.net/view.php?id=542>
-
-Please tell bug-automake@gnu.org about your system, including the value
-of your $PATH and any error possibly output before this message.  This
-can help us improve future automake versions.
-
-END
-  if test x"$ACCEPT_INFERIOR_RM_PROGRAM" = x"yes"; then
-    echo 'Configuration will proceed anyway, since you have set the' >&2
-    echo 'ACCEPT_INFERIOR_RM_PROGRAM variable to "yes"' >&2
-    echo >&2
-  else
-    cat >&2 <<'END'
-Aborting the configuration process, to ensure you take notice of the issue.
-
-You can download and install GNU coreutils to get an 'rm' implementation
-that behaves properly: <http://www.gnu.org/software/coreutils/>.
-
-If you want to complete the configuration process using your problematic
-'rm' anyway, export the environment variable ACCEPT_INFERIOR_RM_PROGRAM
-to "yes", and re-run configure.
-
-END
-    as_fn_error $? "Your 'rm' program is bad, sorry." "$LINENO" 5
-  fi
-fi
 # Make sure we can run config.sub.
 $SHELL "$ac_aux_dir/config.sub" sun4 >/dev/null 2>&1 ||
   as_fn_error $? "cannot run $SHELL $ac_aux_dir/config.sub" "$LINENO" 5
@@ -4141,65 +4100,6 @@ ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
 ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
 ac_compiler_gnu=$ac_cv_c_compiler_gnu
 
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether $CC understands -c and -o together" >&5
-$as_echo_n "checking whether $CC understands -c and -o together... " >&6; }
-if ${am_cv_prog_cc_c_o+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-  # Make sure it works both with $CC and with simple cc.
-  # Following AC_PROG_CC_C_O, we do the test twice because some
-  # compilers refuse to overwrite an existing .o file with -o,
-  # though they will create one.
-  am_cv_prog_cc_c_o=yes
-  for am_i in 1 2; do
-    if { echo "$as_me:$LINENO: $CC -c conftest.$ac_ext -o conftest2.$ac_objext" >&5
-   ($CC -c conftest.$ac_ext -o conftest2.$ac_objext) >&5 2>&5
-   ac_status=$?
-   echo "$as_me:$LINENO: \$? = $ac_status" >&5
-   (exit $ac_status); } \
-         && test -f conftest2.$ac_objext; then
-      : OK
-    else
-      am_cv_prog_cc_c_o=no
-      break
-    fi
-  done
-  rm -f core conftest*
-  unset am_i
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $am_cv_prog_cc_c_o" >&5
-$as_echo "$am_cv_prog_cc_c_o" >&6; }
-if test "$am_cv_prog_cc_c_o" != yes; then
-   # Losing compiler, so override with the script.
-   # FIXME: It is wrong to rewrite CC.
-   # But if we don't then we get into trouble of one sort or another.
-   # A longer-term fix would be to have automake use am__CC in this case,
-   # and then we could set am__CC="\$(top_srcdir)/compile \$(CC)"
-   CC="$am_aux_dir/compile $CC"
-fi
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
-
 depcc="$CC"   am_compiler_list=
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking dependency style of $depcc" >&5
@@ -4328,6 +4228,131 @@ else
 fi
 
 
+if test "x$CC" != xcc; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether $CC and cc understand -c and -o together" >&5
+$as_echo_n "checking whether $CC and cc understand -c and -o together... " >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether cc understands -c and -o together" >&5
+$as_echo_n "checking whether cc understands -c and -o together... " >&6; }
+fi
+set dummy $CC; ac_cc=`$as_echo "$2" |
+		      sed 's/[^a-zA-Z0-9_]/_/g;s/^[0-9]/_/'`
+if eval \${ac_cv_prog_cc_${ac_cc}_c_o+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+int
+main ()
+{
+
+  ;
+  return 0;
+}
+_ACEOF
+# Make sure it works both with $CC and with simple cc.
+# We do the test twice because some compilers refuse to overwrite an
+# existing .o file with -o, though they will create one.
+ac_try='$CC -c conftest.$ac_ext -o conftest2.$ac_objext >&5'
+rm -f conftest2.*
+if { { case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
+$as_echo "$ac_try_echo"; } >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; } &&
+   test -f conftest2.$ac_objext && { { case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
+$as_echo "$ac_try_echo"; } >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; };
+then
+  eval ac_cv_prog_cc_${ac_cc}_c_o=yes
+  if test "x$CC" != xcc; then
+    # Test first that cc exists at all.
+    if { ac_try='cc -c conftest.$ac_ext >&5'
+  { { case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
+$as_echo "$ac_try_echo"; } >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; }; }; then
+      ac_try='cc -c conftest.$ac_ext -o conftest2.$ac_objext >&5'
+      rm -f conftest2.*
+      if { { case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
+$as_echo "$ac_try_echo"; } >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; } &&
+	 test -f conftest2.$ac_objext && { { case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
+$as_echo "$ac_try_echo"; } >&5
+  (eval "$ac_try") 2>&5
+  ac_status=$?
+  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+  test $ac_status = 0; };
+      then
+	# cc works too.
+	:
+      else
+	# cc exists but doesn't like -o.
+	eval ac_cv_prog_cc_${ac_cc}_c_o=no
+      fi
+    fi
+  fi
+else
+  eval ac_cv_prog_cc_${ac_cc}_c_o=no
+fi
+rm -f core conftest*
+
+fi
+if eval test \$ac_cv_prog_cc_${ac_cc}_c_o = yes; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+
+$as_echo "#define NO_MINUS_C_MINUS_O 1" >>confdefs.h
+
+fi
+
+# FIXME: we rely on the cache variable name because
+# there is no other way.
+set dummy $CC
+am_cc=`echo $2 | sed 's/[^a-zA-Z0-9_]/_/g;s/^[0-9]/_/'`
+eval am_t=\$ac_cv_prog_cc_${am_cc}_c_o
+if test "$am_t" != yes; then
+   # Losing compiler, so override with the script.
+   # FIXME: It is wrong to rewrite CC.
+   # But if we don't then we get into trouble of one sort or another.
+   # A longer-term fix would be to have automake use am__CC in this case,
+   # and then we could set am__CC="\$(top_srcdir)/compile \$(CC)"
+   CC="$am_aux_dir/compile $CC"
+fi
+
 
 
 ac_ext=c
@@ -9122,7 +9147,7 @@ if test "x$GCC" = "xyes"; then
 fi
 
 # Files requiring some variable expansion
-ac_config_files="$ac_config_files Makefile lxc.pc lxc.spec config/Makefile config/apparmor/Makefile config/bash/Makefile config/bash/lxc config/init/Makefile config/init/sysvinit/Makefile config/init/sysvinit/lxc config/init/systemd/Makefile config/init/systemd/lxc.service config/init/upstart/Makefile config/etc/Makefile config/templates/Makefile config/templates/centos.common.conf config/templates/centos.userns.conf config/templates/debian.common.conf config/templates/debian.userns.conf config/templates/fedora.common.conf config/templates/fedora.userns.conf config/templates/gentoo.common.conf config/templates/gentoo.moresecure.conf config/templates/gentoo.userns.conf config/templates/oracle.common.conf config/templates/oracle.userns.conf config/templates/plamo.common.conf config/templates/plamo.userns.conf config/templates/ubuntu-cloud.common.conf config/templates/ubuntu-cloud.lucid.conf config/templates/ubuntu-cloud.userns.conf config/templates/ubuntu.common.conf config/templates/ubuntu.lucid.conf config/templates/ubuntu.userns.conf config/yum/Makefile doc/Makefile doc/api/Makefile doc/legacy/lxc-ls.sgml doc/lxc-attach.sgml doc/lxc-autostart.sgml doc/lxc-cgroup.sgml doc/lxc-checkconfig.sgml doc/lxc-clone.sgml doc/lxc-config.sgml doc/lxc-console.sgml doc/lxc-create.sgml doc/lxc-destroy.sgml doc/lxc-device.sgml doc/lxc-execute.sgml doc/lxc-freeze.sgml doc/lxc-info.sgml doc/lxc-ls.sgml doc/lxc-monitor.sgml doc/lxc-snapshot.sgml doc/lxc-start-ephemeral.sgml doc/lxc-start.sgml doc/lxc-stop.sgml doc/lxc-top.sgml doc/lxc-unfreeze.sgml doc/lxc-unshare.sgml doc/lxc-user-nic.sgml doc/lxc-usernsexec.sgml doc/lxc-wait.sgml doc/lxc.conf.sgml doc/lxc.container.conf.sgml doc/lxc.system.conf.sgml doc/lxc-usernet.sgml doc/lxc.sgml doc/common_options.sgml doc/see_also.sgml doc/rootfs/Makefile doc/examples/Makefile doc/examples/lxc-macvlan.conf doc/examples/lxc-vlan.conf doc/examples/lxc-no-netns.conf doc/examples/lxc-empty-netns.conf doc/examples/lxc-phys.conf doc/examples/lxc-veth.conf doc/examples/lxc-complex.conf doc/ja/Makefile doc/ja/legacy/lxc-ls.sgml doc/ja/lxc-attach.sgml doc/ja/lxc-autostart.sgml doc/ja/lxc-cgroup.sgml doc/ja/lxc-checkconfig.sgml doc/ja/lxc-clone.sgml doc/ja/lxc-config.sgml doc/ja/lxc-console.sgml doc/ja/lxc-create.sgml doc/ja/lxc-destroy.sgml doc/ja/lxc-device.sgml doc/ja/lxc-execute.sgml doc/ja/lxc-freeze.sgml doc/ja/lxc-info.sgml doc/ja/lxc-ls.sgml doc/ja/lxc-monitor.sgml doc/ja/lxc-snapshot.sgml doc/ja/lxc-start-ephemeral.sgml doc/ja/lxc-start.sgml doc/ja/lxc-stop.sgml doc/ja/lxc-top.sgml doc/ja/lxc-unfreeze.sgml doc/ja/lxc-unshare.sgml doc/ja/lxc-user-nic.sgml doc/ja/lxc-usernsexec.sgml doc/ja/lxc-wait.sgml doc/ja/lxc.conf.sgml doc/ja/lxc.container.conf.sgml doc/ja/lxc.system.conf.sgml doc/ja/lxc-usernet.sgml doc/ja/lxc.sgml doc/ja/common_options.sgml doc/ja/see_also.sgml hooks/Makefile templates/Makefile templates/lxc-alpine templates/lxc-altlinux templates/lxc-archlinux templates/lxc-busybox templates/lxc-centos templates/lxc-cirros templates/lxc-debian templates/lxc-download templates/lxc-fedora templates/lxc-gentoo templates/lxc-openmandriva templates/lxc-opensuse templates/lxc-oracle templates/lxc-plamo templates/lxc-sshd templates/lxc-ubuntu templates/lxc-ubuntu-cloud src/Makefile src/lxc/Makefile src/lxc/lxc-checkconfig src/lxc/lxc-ls src/lxc/lxc-start-ephemeral src/lxc/legacy/lxc-ls src/lxc/lxc.functions src/lxc/version.h src/python-lxc/Makefile src/lua-lxc/Makefile src/tests/Makefile src/tests/lxc-test-usernic"
+ac_config_files="$ac_config_files Makefile lxc.pc lxc.spec config/Makefile config/apparmor/Makefile config/bash/Makefile config/bash/lxc config/init/Makefile config/init/sysvinit/Makefile config/init/sysvinit/lxc config/init/systemd/Makefile config/init/systemd/lxc.service config/init/upstart/Makefile config/etc/Makefile config/templates/Makefile config/templates/centos.common.conf config/templates/centos.userns.conf config/templates/debian.common.conf config/templates/debian.userns.conf config/templates/fedora.common.conf config/templates/fedora.userns.conf config/templates/gentoo.common.conf config/templates/gentoo.moresecure.conf config/templates/gentoo.userns.conf config/templates/oracle.common.conf config/templates/oracle.userns.conf config/templates/plamo.common.conf config/templates/plamo.userns.conf config/templates/ubuntu-cloud.common.conf config/templates/ubuntu-cloud.lucid.conf config/templates/ubuntu-cloud.userns.conf config/templates/ubuntu.common.conf config/templates/ubuntu.lucid.conf config/templates/ubuntu.userns.conf config/yum/Makefile doc/Makefile doc/api/Makefile doc/legacy/lxc-ls.sgml doc/lxc-attach.sgml doc/lxc-autostart.sgml doc/lxc-cgroup.sgml doc/lxc-checkconfig.sgml doc/lxc-clone.sgml doc/lxc-config.sgml doc/lxc-console.sgml doc/lxc-create.sgml doc/lxc-destroy.sgml doc/lxc-device.sgml doc/lxc-execute.sgml doc/lxc-freeze.sgml doc/lxc-info.sgml doc/lxc-ls.sgml doc/lxc-monitor.sgml doc/lxc-snapshot.sgml doc/lxc-start-ephemeral.sgml doc/lxc-start.sgml doc/lxc-stop.sgml doc/lxc-top.sgml doc/lxc-unfreeze.sgml doc/lxc-unshare.sgml doc/lxc-user-nic.sgml doc/lxc-usernsexec.sgml doc/lxc-wait.sgml doc/lxc.conf.sgml doc/lxc.container.conf.sgml doc/lxc.system.conf.sgml doc/lxc-usernet.sgml doc/lxc.sgml doc/common_options.sgml doc/see_also.sgml doc/rootfs/Makefile doc/examples/Makefile doc/examples/lxc-macvlan.conf doc/examples/lxc-vlan.conf doc/examples/lxc-no-netns.conf doc/examples/lxc-empty-netns.conf doc/examples/lxc-phys.conf doc/examples/lxc-veth.conf doc/examples/lxc-complex.conf doc/ja/Makefile doc/ja/legacy/lxc-ls.sgml doc/ja/lxc-attach.sgml doc/ja/lxc-autostart.sgml doc/ja/lxc-cgroup.sgml doc/ja/lxc-checkconfig.sgml doc/ja/lxc-clone.sgml doc/ja/lxc-config.sgml doc/ja/lxc-console.sgml doc/ja/lxc-create.sgml doc/ja/lxc-destroy.sgml doc/ja/lxc-device.sgml doc/ja/lxc-execute.sgml doc/ja/lxc-freeze.sgml doc/ja/lxc-info.sgml doc/ja/lxc-ls.sgml doc/ja/lxc-monitor.sgml doc/ja/lxc-snapshot.sgml doc/ja/lxc-start-ephemeral.sgml doc/ja/lxc-start.sgml doc/ja/lxc-stop.sgml doc/ja/lxc-top.sgml doc/ja/lxc-unfreeze.sgml doc/ja/lxc-unshare.sgml doc/ja/lxc-user-nic.sgml doc/ja/lxc-usernsexec.sgml doc/ja/lxc-wait.sgml doc/ja/lxc.conf.sgml doc/ja/lxc.container.conf.sgml doc/ja/lxc.system.conf.sgml doc/ja/lxc-usernet.sgml doc/ja/lxc.sgml doc/ja/common_options.sgml doc/ja/see_also.sgml hooks/Makefile templates/Makefile templates/lxc-alpine templates/lxc-altlinux templates/lxc-archlinux templates/lxc-busybox templates/lxc-centos templates/lxc-cirros templates/lxc-debian templates/lxc-download templates/lxc-fedora templates/lxc-gentoo templates/lxc-openmandriva templates/lxc-opensuse templates/lxc-oracle templates/lxc-plamo templates/lxc-sshd templates/lxc-ubuntu templates/lxc-ubuntu-cloud src/Makefile src/lxc/Makefile src/lxc/lxc-checkconfig src/lxc/lxc-ls src/lxc/lxc-start-ephemeral src/lxc/legacy/lxc-ls src/lxc/lxc.functions src/lxc/version.h src/python-lxc/Makefile src/lua-lxc/Makefile src/tests/Makefile src/tests/lxc-test-usernic lcrso/Makefile"
 
 ac_config_commands="$ac_config_commands default"
 
@@ -10102,6 +10127,7 @@ do
     "src/lua-lxc/Makefile") CONFIG_FILES="$CONFIG_FILES src/lua-lxc/Makefile" ;;
     "src/tests/Makefile") CONFIG_FILES="$CONFIG_FILES src/tests/Makefile" ;;
     "src/tests/lxc-test-usernic") CONFIG_FILES="$CONFIG_FILES src/tests/lxc-test-usernic" ;;
+    "lcrso/Makefile") CONFIG_FILES="$CONFIG_FILES lcrso/Makefile" ;;
     "default") CONFIG_COMMANDS="$CONFIG_COMMANDS default" ;;
 
   *) as_fn_error $? "invalid argument: \`$ac_config_target'" "$LINENO" 5;;
diff --git a/configure.ac b/configure.ac
index 5f8cdac..853957e 100644
--- a/configure.ac
+++ b/configure.ac
@@ -721,6 +721,7 @@ AC_CONFIG_FILES([
 
 	src/tests/Makefile
 	src/tests/lxc-test-usernic
+	lcrso/Makefile
 ])
 AC_CONFIG_COMMANDS([default],[[]],[[]])
 AC_OUTPUT
diff --git a/doc/Makefile.in b/doc/Makefile.in
index 7c62023..81248e1 100644
--- a/doc/Makefile.in
+++ b/doc/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/doc/api/Makefile.in b/doc/api/Makefile.in
index 664cd22..ecb8140 100644
--- a/doc/api/Makefile.in
+++ b/doc/api/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/doc/examples/Makefile.in b/doc/examples/Makefile.in
index cae3236..79363ec 100644
--- a/doc/examples/Makefile.in
+++ b/doc/examples/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/doc/ja/Makefile.in b/doc/ja/Makefile.in
index 9418db4..1cd533d 100644
--- a/doc/ja/Makefile.in
+++ b/doc/ja/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/doc/rootfs/Makefile.in b/doc/rootfs/Makefile.in
index 465650d..b7e6720 100644
--- a/doc/rootfs/Makefile.in
+++ b/doc/rootfs/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/hooks/Makefile.in b/hooks/Makefile.in
index 01ad1bf..a009e5a 100644
--- a/hooks/Makefile.in
+++ b/hooks/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/lcrso/Makefile.am b/lcrso/Makefile.am
new file mode 100644
index 0000000..dceebde
--- /dev/null
+++ b/lcrso/Makefile.am
@@ -0,0 +1,25 @@
+meminfo_sodir=$(libdir)/lcrso
+cpuinfo_sodir=$(libdir)/lcrso
+stat_sodir=$(libdir)/lcrso
+sysrq_sodir=$(libdir)/lcrso
+LCRSO_CFLAGS=-fPIC -I../src/lxc -fPIC -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=27 -Werror=sizeof-pointer-memaccess
+
+meminfo_so_PROGRAMS = libmeminfo.lcrso
+libmeminfo_lcrso_SOURCES=meminfo.c
+libmeminfo_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libmeminfo_lcrso_LDFLAGS = -shared
+
+cpuinfo_so_PROGRAMS = libcpuinfo.lcrso
+libcpuinfo_lcrso_SOURCES=cpuinfo.c
+libcpuinfo_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libcpuinfo_lcrso_LDFLAGS = -shared
+
+stat_so_PROGRAMS = libstat.lcrso
+libstat_lcrso_SOURCES=stat.c
+libstat_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libstat_lcrso_LDFLAGS = -shared
+
+sysrq_so_PROGRAMS = libsysrq.lcrso
+libsysrq_lcrso_SOURCES=sysrq.c
+libsysrq_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libsysrq_lcrso_LDFLAGS = -shared
diff --git a/lcrso/Makefile.in b/lcrso/Makefile.in
new file mode 100644
index 0000000..45c4797
--- /dev/null
+++ b/lcrso/Makefile.in
@@ -0,0 +1,881 @@
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
+# @configure_input@
+
+# Copyright (C) 1994-2013 Free Software Foundation, Inc.
+
+# This Makefile.in is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
+# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
+# PARTICULAR PURPOSE.
+
+@SET_MAKE@
+
+VPATH = @srcdir@
+am__is_gnu_make = test -n '$(MAKEFILE_LIST)' && test -n '$(MAKELEVEL)'
+am__make_running_with_option = \
+  case $${target_option-} in \
+      ?) ;; \
+      *) echo "am__make_running_with_option: internal error: invalid" \
+              "target option '$${target_option-}' specified" >&2; \
+         exit 1;; \
+  esac; \
+  has_opt=no; \
+  sane_makeflags=$$MAKEFLAGS; \
+  if $(am__is_gnu_make); then \
+    sane_makeflags=$$MFLAGS; \
+  else \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        bs=\\; \
+        sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
+          | sed "s/$$bs$$bs[$$bs $$bs	]*//g"`;; \
+    esac; \
+  fi; \
+  skip_next=no; \
+  strip_trailopt () \
+  { \
+    flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
+  }; \
+  for flg in $$sane_makeflags; do \
+    test $$skip_next = yes && { skip_next=no; continue; }; \
+    case $$flg in \
+      *=*|--*) continue;; \
+        -*I) strip_trailopt 'I'; skip_next=yes;; \
+      -*I?*) strip_trailopt 'I';; \
+        -*O) strip_trailopt 'O'; skip_next=yes;; \
+      -*O?*) strip_trailopt 'O';; \
+        -*l) strip_trailopt 'l'; skip_next=yes;; \
+      -*l?*) strip_trailopt 'l';; \
+      -[dEDm]) skip_next=yes;; \
+      -[JT]) skip_next=yes;; \
+    esac; \
+    case $$flg in \
+      *$$target_option*) has_opt=yes; break;; \
+    esac; \
+  done; \
+  test $$has_opt = yes
+am__make_dryrun = (target_option=n; $(am__make_running_with_option))
+am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
+pkgdatadir = $(datadir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
+pkglibdir = $(libdir)/@PACKAGE@
+pkglibexecdir = $(libexecdir)/@PACKAGE@
+am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
+install_sh_DATA = $(install_sh) -c -m 644
+install_sh_PROGRAM = $(install_sh) -c
+install_sh_SCRIPT = $(install_sh) -c
+INSTALL_HEADER = $(INSTALL_DATA)
+transform = $(program_transform_name)
+NORMAL_INSTALL = :
+PRE_INSTALL = :
+POST_INSTALL = :
+NORMAL_UNINSTALL = :
+PRE_UNINSTALL = :
+POST_UNINSTALL = :
+build_triplet = @build@
+host_triplet = @host@
+meminfo_so_PROGRAMS = libmeminfo.lcrso$(EXEEXT)
+cpuinfo_so_PROGRAMS = libcpuinfo.lcrso$(EXEEXT)
+stat_so_PROGRAMS = libstat.lcrso$(EXEEXT)
+sysrq_so_PROGRAMS = libsysrq.lcrso$(EXEEXT)
+subdir = lcrso
+DIST_COMMON = $(srcdir)/Makefile.in $(srcdir)/Makefile.am \
+	$(top_srcdir)/config/depcomp
+ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
+am__aclocal_m4_deps = $(top_srcdir)/config/acinclude.m4 \
+	$(top_srcdir)/config/tls.m4 $(top_srcdir)/configure.ac
+am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
+	$(ACLOCAL_M4)
+mkinstalldirs = $(install_sh) -d
+CONFIG_HEADER = $(top_builddir)/src/config.h
+CONFIG_CLEAN_FILES =
+CONFIG_CLEAN_VPATH_FILES =
+am__installdirs = "$(DESTDIR)$(cpuinfo_sodir)" \
+	"$(DESTDIR)$(meminfo_sodir)" "$(DESTDIR)$(stat_sodir)" \
+	"$(DESTDIR)$(sysrq_sodir)"
+PROGRAMS = $(cpuinfo_so_PROGRAMS) $(meminfo_so_PROGRAMS) \
+	$(stat_so_PROGRAMS) $(sysrq_so_PROGRAMS)
+am_libcpuinfo_lcrso_OBJECTS = libcpuinfo_lcrso-cpuinfo.$(OBJEXT)
+libcpuinfo_lcrso_OBJECTS = $(am_libcpuinfo_lcrso_OBJECTS)
+libcpuinfo_lcrso_LDADD = $(LDADD)
+libcpuinfo_lcrso_LINK = $(CCLD) $(libcpuinfo_lcrso_CFLAGS) $(CFLAGS) \
+	$(libcpuinfo_lcrso_LDFLAGS) $(LDFLAGS) -o $@
+am_libmeminfo_lcrso_OBJECTS = libmeminfo_lcrso-meminfo.$(OBJEXT)
+libmeminfo_lcrso_OBJECTS = $(am_libmeminfo_lcrso_OBJECTS)
+libmeminfo_lcrso_LDADD = $(LDADD)
+libmeminfo_lcrso_LINK = $(CCLD) $(libmeminfo_lcrso_CFLAGS) $(CFLAGS) \
+	$(libmeminfo_lcrso_LDFLAGS) $(LDFLAGS) -o $@
+am_libstat_lcrso_OBJECTS = libstat_lcrso-stat.$(OBJEXT)
+libstat_lcrso_OBJECTS = $(am_libstat_lcrso_OBJECTS)
+libstat_lcrso_LDADD = $(LDADD)
+libstat_lcrso_LINK = $(CCLD) $(libstat_lcrso_CFLAGS) $(CFLAGS) \
+	$(libstat_lcrso_LDFLAGS) $(LDFLAGS) -o $@
+am_libsysrq_lcrso_OBJECTS = libsysrq_lcrso-sysrq.$(OBJEXT)
+libsysrq_lcrso_OBJECTS = $(am_libsysrq_lcrso_OBJECTS)
+libsysrq_lcrso_LDADD = $(LDADD)
+libsysrq_lcrso_LINK = $(CCLD) $(libsysrq_lcrso_CFLAGS) $(CFLAGS) \
+	$(libsysrq_lcrso_LDFLAGS) $(LDFLAGS) -o $@
+AM_V_P = $(am__v_P_@AM_V@)
+am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
+am__v_P_0 = false
+am__v_P_1 = :
+AM_V_GEN = $(am__v_GEN_@AM_V@)
+am__v_GEN_ = $(am__v_GEN_@AM_DEFAULT_V@)
+am__v_GEN_0 = @echo "  GEN     " $@;
+am__v_GEN_1 = 
+AM_V_at = $(am__v_at_@AM_V@)
+am__v_at_ = $(am__v_at_@AM_DEFAULT_V@)
+am__v_at_0 = @
+am__v_at_1 = 
+DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir)/src
+depcomp = $(SHELL) $(top_srcdir)/config/depcomp
+am__depfiles_maybe = depfiles
+am__mv = mv -f
+AM_V_lt = $(am__v_lt_@AM_V@)
+am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
+am__v_lt_0 = --silent
+am__v_lt_1 = 
+COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
+	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
+AM_V_CC = $(am__v_CC_@AM_V@)
+am__v_CC_ = $(am__v_CC_@AM_DEFAULT_V@)
+am__v_CC_0 = @echo "  CC      " $@;
+am__v_CC_1 = 
+CCLD = $(CC)
+LINK = $(CCLD) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
+AM_V_CCLD = $(am__v_CCLD_@AM_V@)
+am__v_CCLD_ = $(am__v_CCLD_@AM_DEFAULT_V@)
+am__v_CCLD_0 = @echo "  CCLD    " $@;
+am__v_CCLD_1 = 
+SOURCES = $(libcpuinfo_lcrso_SOURCES) $(libmeminfo_lcrso_SOURCES) \
+	$(libstat_lcrso_SOURCES) $(libsysrq_lcrso_SOURCES)
+DIST_SOURCES = $(libcpuinfo_lcrso_SOURCES) $(libmeminfo_lcrso_SOURCES) \
+	$(libstat_lcrso_SOURCES) $(libsysrq_lcrso_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
+am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
+# Read a list of newline-separated strings from the standard input,
+# and print each of them once, without duplicates.  Input order is
+# *not* preserved.
+am__uniquify_input = $(AWK) '\
+  BEGIN { nonempty = 0; } \
+  { items[$$0] = 1; nonempty = 1; } \
+  END { if (nonempty) { for (i in items) print i; }; } \
+'
+# Make sure the list of sources is unique.  This is necessary because,
+# e.g., the same source file might be shared among _SOURCES variables
+# for different programs/libraries.
+am__define_uniq_tagged_files = \
+  list='$(am__tagged_files)'; \
+  unique=`for i in $$list; do \
+    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+  done | $(am__uniquify_input)`
+ETAGS = etags
+CTAGS = ctags
+DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
+ACLOCAL = @ACLOCAL@
+AMTAR = @AMTAR@
+AM_DEFAULT_VERBOSITY = @AM_DEFAULT_VERBOSITY@
+APPARMOR_LIBS = @APPARMOR_LIBS@
+AUTOCONF = @AUTOCONF@
+AUTOHEADER = @AUTOHEADER@
+AUTOMAKE = @AUTOMAKE@
+AWK = @AWK@
+BINDIR = @BINDIR@
+CAP_LIBS = @CAP_LIBS@
+CC = @CC@
+CCDEPMODE = @CCDEPMODE@
+CFLAGS = @CFLAGS@
+CGMANAGER_CFLAGS = @CGMANAGER_CFLAGS@
+CGMANAGER_LIBS = @CGMANAGER_LIBS@
+CPP = @CPP@
+CPPFLAGS = @CPPFLAGS@
+CYGPATH_W = @CYGPATH_W@
+DATADIR = @DATADIR@
+DBUS_CFLAGS = @DBUS_CFLAGS@
+DBUS_LIBS = @DBUS_LIBS@
+DEFAULT_CGROUP_PATTERN = @DEFAULT_CGROUP_PATTERN@
+DEFS = @DEFS@
+DEPDIR = @DEPDIR@
+DOCDIR = @DOCDIR@
+ECHO_C = @ECHO_C@
+ECHO_N = @ECHO_N@
+ECHO_T = @ECHO_T@
+EGREP = @EGREP@
+EXEEXT = @EXEEXT@
+GREP = @GREP@
+HAVE_DOXYGEN = @HAVE_DOXYGEN@
+INCLUDEDIR = @INCLUDEDIR@
+INSTALL = @INSTALL@
+INSTALL_DATA = @INSTALL_DATA@
+INSTALL_PROGRAM = @INSTALL_PROGRAM@
+INSTALL_SCRIPT = @INSTALL_SCRIPT@
+INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+LDFLAGS = @LDFLAGS@
+LIBDIR = @LIBDIR@
+LIBEXECDIR = @LIBEXECDIR@
+LIBOBJS = @LIBOBJS@
+LIBS = @LIBS@
+LOCALSTATEDIR = @LOCALSTATEDIR@
+LOGPATH = @LOGPATH@
+LTLIBOBJS = @LTLIBOBJS@
+LUA_CFLAGS = @LUA_CFLAGS@
+LUA_LIBDIR = @LUA_LIBDIR@
+LUA_LIBS = @LUA_LIBS@
+LUA_SHAREDIR = @LUA_SHAREDIR@
+LUA_VERSION = @LUA_VERSION@
+LXCHOOKDIR = @LXCHOOKDIR@
+LXCINITDIR = @LXCINITDIR@
+LXCPATH = @LXCPATH@
+LXCROOTFSMOUNT = @LXCROOTFSMOUNT@
+LXCTEMPLATECONFIG = @LXCTEMPLATECONFIG@
+LXCTEMPLATEDIR = @LXCTEMPLATEDIR@
+LXC_DEFAULT_CONFIG = @LXC_DEFAULT_CONFIG@
+LXC_DISTRO_CONF = @LXC_DISTRO_CONF@
+LXC_GENERATE_DATE = @LXC_GENERATE_DATE@
+LXC_GLOBAL_CONF = @LXC_GLOBAL_CONF@
+LXC_USERNIC_CONF = @LXC_USERNIC_CONF@
+LXC_USERNIC_DB = @LXC_USERNIC_DB@
+LXC_VERSION = @LXC_VERSION@
+LXC_VERSION_BASE = @LXC_VERSION_BASE@
+LXC_VERSION_BETA = @LXC_VERSION_BETA@
+LXC_VERSION_MAJOR = @LXC_VERSION_MAJOR@
+LXC_VERSION_MICRO = @LXC_VERSION_MICRO@
+LXC_VERSION_MINOR = @LXC_VERSION_MINOR@
+MAKEINFO = @MAKEINFO@
+MKDIR_P = @MKDIR_P@
+NIH_CFLAGS = @NIH_CFLAGS@
+NIH_DBUS_CFLAGS = @NIH_DBUS_CFLAGS@
+NIH_DBUS_LIBS = @NIH_DBUS_LIBS@
+NIH_LIBS = @NIH_LIBS@
+OBJEXT = @OBJEXT@
+PACKAGE = @PACKAGE@
+PACKAGE_BUGREPORT = @PACKAGE_BUGREPORT@
+PACKAGE_NAME = @PACKAGE_NAME@
+PACKAGE_STRING = @PACKAGE_STRING@
+PACKAGE_TARNAME = @PACKAGE_TARNAME@
+PACKAGE_URL = @PACKAGE_URL@
+PACKAGE_VERSION = @PACKAGE_VERSION@
+PATH_SEPARATOR = @PATH_SEPARATOR@
+PKG_CONFIG = @PKG_CONFIG@
+PKG_CONFIG_LIBDIR = @PKG_CONFIG_LIBDIR@
+PKG_CONFIG_PATH = @PKG_CONFIG_PATH@
+PREFIX = @PREFIX@
+PYTHON = @PYTHON@
+PYTHONDEV_CFLAGS = @PYTHONDEV_CFLAGS@
+PYTHONDEV_LIBS = @PYTHONDEV_LIBS@
+PYTHON_EXEC_PREFIX = @PYTHON_EXEC_PREFIX@
+PYTHON_PLATFORM = @PYTHON_PLATFORM@
+PYTHON_PREFIX = @PYTHON_PREFIX@
+PYTHON_VERSION = @PYTHON_VERSION@
+RUNTIME_PATH = @RUNTIME_PATH@
+SBINDIR = @SBINDIR@
+SECCOMP_CFLAGS = @SECCOMP_CFLAGS@
+SECCOMP_LIBS = @SECCOMP_LIBS@
+SED = @SED@
+SELINUX_LIBS = @SELINUX_LIBS@
+SET_MAKE = @SET_MAKE@
+SHELL = @SHELL@
+STRIP = @STRIP@
+SYSCONFDIR = @SYSCONFDIR@
+VERSION = @VERSION@
+abs_builddir = @abs_builddir@
+abs_srcdir = @abs_srcdir@
+abs_top_builddir = @abs_top_builddir@
+abs_top_srcdir = @abs_top_srcdir@
+ac_ct_CC = @ac_ct_CC@
+am__include = @am__include@
+am__leading_dot = @am__leading_dot@
+am__quote = @am__quote@
+am__tar = @am__tar@
+am__untar = @am__untar@
+bindir = @bindir@
+build = @build@
+build_alias = @build_alias@
+build_cpu = @build_cpu@
+build_os = @build_os@
+build_vendor = @build_vendor@
+builddir = @builddir@
+datadir = @datadir@
+datarootdir = @datarootdir@
+db2xman = @db2xman@
+docdir = @docdir@
+docdtd = @docdtd@
+dvidir = @dvidir@
+exec_prefix = @exec_prefix@
+host = @host@
+host_alias = @host_alias@
+host_cpu = @host_cpu@
+host_os = @host_os@
+host_vendor = @host_vendor@
+htmldir = @htmldir@
+includedir = @includedir@
+infodir = @infodir@
+install_sh = @install_sh@
+libdir = @libdir@
+libexecdir = @libexecdir@
+localedir = @localedir@
+localstatedir = @localstatedir@
+mandir = @mandir@
+mkdir_p = @mkdir_p@
+oldincludedir = @oldincludedir@
+pdfdir = @pdfdir@
+pkgpyexecdir = @pkgpyexecdir@
+pkgpythondir = @pkgpythondir@
+prefix = @prefix@
+program_transform_name = @program_transform_name@
+psdir = @psdir@
+pyexecdir = @pyexecdir@
+pythondir = @pythondir@
+sbindir = @sbindir@
+sharedstatedir = @sharedstatedir@
+srcdir = @srcdir@
+sysconfdir = @sysconfdir@
+target_alias = @target_alias@
+top_build_prefix = @top_build_prefix@
+top_builddir = @top_builddir@
+top_srcdir = @top_srcdir@
+meminfo_sodir = $(libdir)/lcrso
+cpuinfo_sodir = $(libdir)/lcrso
+stat_sodir = $(libdir)/lcrso
+sysrq_sodir = $(libdir)/lcrso
+LCRSO_CFLAGS = -fPIC -I../src/lxc -fPIC -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=27 -Werror=sizeof-pointer-memaccess
+libmeminfo_lcrso_SOURCES = meminfo.c
+libmeminfo_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libmeminfo_lcrso_LDFLAGS = -shared
+libcpuinfo_lcrso_SOURCES = cpuinfo.c
+libcpuinfo_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libcpuinfo_lcrso_LDFLAGS = -shared
+libstat_lcrso_SOURCES = stat.c
+libstat_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libstat_lcrso_LDFLAGS = -shared
+libsysrq_lcrso_SOURCES = sysrq.c
+libsysrq_lcrso_CFLAGS = ${LCRSO_CFLAGS}
+libsysrq_lcrso_LDFLAGS = -shared
+all: all-am
+
+.SUFFIXES:
+.SUFFIXES: .c .o .obj
+$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am  $(am__configure_deps)
+	@for dep in $?; do \
+	  case '$(am__configure_deps)' in \
+	    *$$dep*) \
+	      ( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
+	        && { if test -f $@; then exit 0; else break; fi; }; \
+	      exit 1;; \
+	  esac; \
+	done; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu lcrso/Makefile'; \
+	$(am__cd) $(top_srcdir) && \
+	  $(AUTOMAKE) --gnu lcrso/Makefile
+.PRECIOUS: Makefile
+Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+	@case '$?' in \
+	  *config.status*) \
+	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
+	  *) \
+	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
+	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
+	esac;
+
+$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+
+$(top_srcdir)/configure:  $(am__configure_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(ACLOCAL_M4):  $(am__aclocal_m4_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(am__aclocal_m4_deps):
+install-cpuinfo_soPROGRAMS: $(cpuinfo_so_PROGRAMS)
+	@$(NORMAL_INSTALL)
+	@list='$(cpuinfo_so_PROGRAMS)'; test -n "$(cpuinfo_sodir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(cpuinfo_sodir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(cpuinfo_sodir)" || exit 1; \
+	fi; \
+	for p in $$list; do echo "$$p $$p"; done | \
+	sed 's/$(EXEEXT)$$//' | \
+	while read p p1; do if test -f $$p \
+	  ; then echo "$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n;h' \
+	    -e 's|.*|.|' \
+	    -e 'p;x;s,.*/,,;s/$(EXEEXT)$$//;$(transform);s/$$/$(EXEEXT)/' | \
+	sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1 } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) files[d] = files[d] " " $$1; \
+	    else { print "f", $$3 "/" $$4, $$1; } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	    if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	    test -z "$$files" || { \
+	      echo " $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files '$(DESTDIR)$(cpuinfo_sodir)$$dir'"; \
+	      $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files "$(DESTDIR)$(cpuinfo_sodir)$$dir" || exit $$?; \
+	    } \
+	; done
+
+uninstall-cpuinfo_soPROGRAMS:
+	@$(NORMAL_UNINSTALL)
+	@list='$(cpuinfo_so_PROGRAMS)'; test -n "$(cpuinfo_sodir)" || list=; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	  sed -e 'h;s,^.*/,,;s/$(EXEEXT)$$//;$(transform)' \
+	      -e 's/$$/$(EXEEXT)/' \
+	`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(cpuinfo_sodir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(cpuinfo_sodir)" && rm -f $$files
+
+clean-cpuinfo_soPROGRAMS:
+	-test -z "$(cpuinfo_so_PROGRAMS)" || rm -f $(cpuinfo_so_PROGRAMS)
+install-meminfo_soPROGRAMS: $(meminfo_so_PROGRAMS)
+	@$(NORMAL_INSTALL)
+	@list='$(meminfo_so_PROGRAMS)'; test -n "$(meminfo_sodir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(meminfo_sodir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(meminfo_sodir)" || exit 1; \
+	fi; \
+	for p in $$list; do echo "$$p $$p"; done | \
+	sed 's/$(EXEEXT)$$//' | \
+	while read p p1; do if test -f $$p \
+	  ; then echo "$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n;h' \
+	    -e 's|.*|.|' \
+	    -e 'p;x;s,.*/,,;s/$(EXEEXT)$$//;$(transform);s/$$/$(EXEEXT)/' | \
+	sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1 } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) files[d] = files[d] " " $$1; \
+	    else { print "f", $$3 "/" $$4, $$1; } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	    if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	    test -z "$$files" || { \
+	      echo " $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files '$(DESTDIR)$(meminfo_sodir)$$dir'"; \
+	      $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files "$(DESTDIR)$(meminfo_sodir)$$dir" || exit $$?; \
+	    } \
+	; done
+
+uninstall-meminfo_soPROGRAMS:
+	@$(NORMAL_UNINSTALL)
+	@list='$(meminfo_so_PROGRAMS)'; test -n "$(meminfo_sodir)" || list=; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	  sed -e 'h;s,^.*/,,;s/$(EXEEXT)$$//;$(transform)' \
+	      -e 's/$$/$(EXEEXT)/' \
+	`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(meminfo_sodir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(meminfo_sodir)" && rm -f $$files
+
+clean-meminfo_soPROGRAMS:
+	-test -z "$(meminfo_so_PROGRAMS)" || rm -f $(meminfo_so_PROGRAMS)
+install-stat_soPROGRAMS: $(stat_so_PROGRAMS)
+	@$(NORMAL_INSTALL)
+	@list='$(stat_so_PROGRAMS)'; test -n "$(stat_sodir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(stat_sodir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(stat_sodir)" || exit 1; \
+	fi; \
+	for p in $$list; do echo "$$p $$p"; done | \
+	sed 's/$(EXEEXT)$$//' | \
+	while read p p1; do if test -f $$p \
+	  ; then echo "$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n;h' \
+	    -e 's|.*|.|' \
+	    -e 'p;x;s,.*/,,;s/$(EXEEXT)$$//;$(transform);s/$$/$(EXEEXT)/' | \
+	sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1 } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) files[d] = files[d] " " $$1; \
+	    else { print "f", $$3 "/" $$4, $$1; } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	    if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	    test -z "$$files" || { \
+	      echo " $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files '$(DESTDIR)$(stat_sodir)$$dir'"; \
+	      $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files "$(DESTDIR)$(stat_sodir)$$dir" || exit $$?; \
+	    } \
+	; done
+
+uninstall-stat_soPROGRAMS:
+	@$(NORMAL_UNINSTALL)
+	@list='$(stat_so_PROGRAMS)'; test -n "$(stat_sodir)" || list=; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	  sed -e 'h;s,^.*/,,;s/$(EXEEXT)$$//;$(transform)' \
+	      -e 's/$$/$(EXEEXT)/' \
+	`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(stat_sodir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(stat_sodir)" && rm -f $$files
+
+clean-stat_soPROGRAMS:
+	-test -z "$(stat_so_PROGRAMS)" || rm -f $(stat_so_PROGRAMS)
+install-sysrq_soPROGRAMS: $(sysrq_so_PROGRAMS)
+	@$(NORMAL_INSTALL)
+	@list='$(sysrq_so_PROGRAMS)'; test -n "$(sysrq_sodir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(sysrq_sodir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(sysrq_sodir)" || exit 1; \
+	fi; \
+	for p in $$list; do echo "$$p $$p"; done | \
+	sed 's/$(EXEEXT)$$//' | \
+	while read p p1; do if test -f $$p \
+	  ; then echo "$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n;h' \
+	    -e 's|.*|.|' \
+	    -e 'p;x;s,.*/,,;s/$(EXEEXT)$$//;$(transform);s/$$/$(EXEEXT)/' | \
+	sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1 } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) files[d] = files[d] " " $$1; \
+	    else { print "f", $$3 "/" $$4, $$1; } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	    if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	    test -z "$$files" || { \
+	      echo " $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files '$(DESTDIR)$(sysrq_sodir)$$dir'"; \
+	      $(INSTALL_PROGRAM_ENV) $(INSTALL_PROGRAM) $$files "$(DESTDIR)$(sysrq_sodir)$$dir" || exit $$?; \
+	    } \
+	; done
+
+uninstall-sysrq_soPROGRAMS:
+	@$(NORMAL_UNINSTALL)
+	@list='$(sysrq_so_PROGRAMS)'; test -n "$(sysrq_sodir)" || list=; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	  sed -e 'h;s,^.*/,,;s/$(EXEEXT)$$//;$(transform)' \
+	      -e 's/$$/$(EXEEXT)/' \
+	`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(sysrq_sodir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(sysrq_sodir)" && rm -f $$files
+
+clean-sysrq_soPROGRAMS:
+	-test -z "$(sysrq_so_PROGRAMS)" || rm -f $(sysrq_so_PROGRAMS)
+
+libcpuinfo.lcrso$(EXEEXT): $(libcpuinfo_lcrso_OBJECTS) $(libcpuinfo_lcrso_DEPENDENCIES) $(EXTRA_libcpuinfo_lcrso_DEPENDENCIES) 
+	@rm -f libcpuinfo.lcrso$(EXEEXT)
+	$(AM_V_CCLD)$(libcpuinfo_lcrso_LINK) $(libcpuinfo_lcrso_OBJECTS) $(libcpuinfo_lcrso_LDADD) $(LIBS)
+
+libmeminfo.lcrso$(EXEEXT): $(libmeminfo_lcrso_OBJECTS) $(libmeminfo_lcrso_DEPENDENCIES) $(EXTRA_libmeminfo_lcrso_DEPENDENCIES) 
+	@rm -f libmeminfo.lcrso$(EXEEXT)
+	$(AM_V_CCLD)$(libmeminfo_lcrso_LINK) $(libmeminfo_lcrso_OBJECTS) $(libmeminfo_lcrso_LDADD) $(LIBS)
+
+libstat.lcrso$(EXEEXT): $(libstat_lcrso_OBJECTS) $(libstat_lcrso_DEPENDENCIES) $(EXTRA_libstat_lcrso_DEPENDENCIES) 
+	@rm -f libstat.lcrso$(EXEEXT)
+	$(AM_V_CCLD)$(libstat_lcrso_LINK) $(libstat_lcrso_OBJECTS) $(libstat_lcrso_LDADD) $(LIBS)
+
+libsysrq.lcrso$(EXEEXT): $(libsysrq_lcrso_OBJECTS) $(libsysrq_lcrso_DEPENDENCIES) $(EXTRA_libsysrq_lcrso_DEPENDENCIES) 
+	@rm -f libsysrq.lcrso$(EXEEXT)
+	$(AM_V_CCLD)$(libsysrq_lcrso_LINK) $(libsysrq_lcrso_OBJECTS) $(libsysrq_lcrso_LDADD) $(LIBS)
+
+mostlyclean-compile:
+	-rm -f *.$(OBJEXT)
+
+distclean-compile:
+	-rm -f *.tab.c
+
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libmeminfo_lcrso-meminfo.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libstat_lcrso-stat.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libsysrq_lcrso-sysrq.Po@am__quote@
+
+.c.o:
+@am__fastdepCC_TRUE@	$(AM_V_CC)depbase=`echo $@ | sed 's|[^/]*$$|$(DEPDIR)/&|;s|\.o$$||'`;\
+@am__fastdepCC_TRUE@	$(COMPILE) -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ $< &&\
+@am__fastdepCC_TRUE@	$(am__mv) $$depbase.Tpo $$depbase.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(COMPILE) -c -o $@ $<
+
+.c.obj:
+@am__fastdepCC_TRUE@	$(AM_V_CC)depbase=`echo $@ | sed 's|[^/]*$$|$(DEPDIR)/&|;s|\.obj$$||'`;\
+@am__fastdepCC_TRUE@	$(COMPILE) -MT $@ -MD -MP -MF $$depbase.Tpo -c -o $@ `$(CYGPATH_W) '$<'` &&\
+@am__fastdepCC_TRUE@	$(am__mv) $$depbase.Tpo $$depbase.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(COMPILE) -c -o $@ `$(CYGPATH_W) '$<'`
+
+libcpuinfo_lcrso-cpuinfo.o: cpuinfo.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcpuinfo_lcrso_CFLAGS) $(CFLAGS) -MT libcpuinfo_lcrso-cpuinfo.o -MD -MP -MF $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Tpo -c -o libcpuinfo_lcrso-cpuinfo.o `test -f 'cpuinfo.c' || echo '$(srcdir)/'`cpuinfo.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Tpo $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='cpuinfo.c' object='libcpuinfo_lcrso-cpuinfo.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcpuinfo_lcrso_CFLAGS) $(CFLAGS) -c -o libcpuinfo_lcrso-cpuinfo.o `test -f 'cpuinfo.c' || echo '$(srcdir)/'`cpuinfo.c
+
+libcpuinfo_lcrso-cpuinfo.obj: cpuinfo.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcpuinfo_lcrso_CFLAGS) $(CFLAGS) -MT libcpuinfo_lcrso-cpuinfo.obj -MD -MP -MF $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Tpo -c -o libcpuinfo_lcrso-cpuinfo.obj `if test -f 'cpuinfo.c'; then $(CYGPATH_W) 'cpuinfo.c'; else $(CYGPATH_W) '$(srcdir)/cpuinfo.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Tpo $(DEPDIR)/libcpuinfo_lcrso-cpuinfo.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='cpuinfo.c' object='libcpuinfo_lcrso-cpuinfo.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcpuinfo_lcrso_CFLAGS) $(CFLAGS) -c -o libcpuinfo_lcrso-cpuinfo.obj `if test -f 'cpuinfo.c'; then $(CYGPATH_W) 'cpuinfo.c'; else $(CYGPATH_W) '$(srcdir)/cpuinfo.c'; fi`
+
+libmeminfo_lcrso-meminfo.o: meminfo.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libmeminfo_lcrso_CFLAGS) $(CFLAGS) -MT libmeminfo_lcrso-meminfo.o -MD -MP -MF $(DEPDIR)/libmeminfo_lcrso-meminfo.Tpo -c -o libmeminfo_lcrso-meminfo.o `test -f 'meminfo.c' || echo '$(srcdir)/'`meminfo.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libmeminfo_lcrso-meminfo.Tpo $(DEPDIR)/libmeminfo_lcrso-meminfo.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='meminfo.c' object='libmeminfo_lcrso-meminfo.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libmeminfo_lcrso_CFLAGS) $(CFLAGS) -c -o libmeminfo_lcrso-meminfo.o `test -f 'meminfo.c' || echo '$(srcdir)/'`meminfo.c
+
+libmeminfo_lcrso-meminfo.obj: meminfo.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libmeminfo_lcrso_CFLAGS) $(CFLAGS) -MT libmeminfo_lcrso-meminfo.obj -MD -MP -MF $(DEPDIR)/libmeminfo_lcrso-meminfo.Tpo -c -o libmeminfo_lcrso-meminfo.obj `if test -f 'meminfo.c'; then $(CYGPATH_W) 'meminfo.c'; else $(CYGPATH_W) '$(srcdir)/meminfo.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libmeminfo_lcrso-meminfo.Tpo $(DEPDIR)/libmeminfo_lcrso-meminfo.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='meminfo.c' object='libmeminfo_lcrso-meminfo.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libmeminfo_lcrso_CFLAGS) $(CFLAGS) -c -o libmeminfo_lcrso-meminfo.obj `if test -f 'meminfo.c'; then $(CYGPATH_W) 'meminfo.c'; else $(CYGPATH_W) '$(srcdir)/meminfo.c'; fi`
+
+libstat_lcrso-stat.o: stat.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libstat_lcrso_CFLAGS) $(CFLAGS) -MT libstat_lcrso-stat.o -MD -MP -MF $(DEPDIR)/libstat_lcrso-stat.Tpo -c -o libstat_lcrso-stat.o `test -f 'stat.c' || echo '$(srcdir)/'`stat.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libstat_lcrso-stat.Tpo $(DEPDIR)/libstat_lcrso-stat.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='stat.c' object='libstat_lcrso-stat.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libstat_lcrso_CFLAGS) $(CFLAGS) -c -o libstat_lcrso-stat.o `test -f 'stat.c' || echo '$(srcdir)/'`stat.c
+
+libstat_lcrso-stat.obj: stat.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libstat_lcrso_CFLAGS) $(CFLAGS) -MT libstat_lcrso-stat.obj -MD -MP -MF $(DEPDIR)/libstat_lcrso-stat.Tpo -c -o libstat_lcrso-stat.obj `if test -f 'stat.c'; then $(CYGPATH_W) 'stat.c'; else $(CYGPATH_W) '$(srcdir)/stat.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libstat_lcrso-stat.Tpo $(DEPDIR)/libstat_lcrso-stat.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='stat.c' object='libstat_lcrso-stat.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libstat_lcrso_CFLAGS) $(CFLAGS) -c -o libstat_lcrso-stat.obj `if test -f 'stat.c'; then $(CYGPATH_W) 'stat.c'; else $(CYGPATH_W) '$(srcdir)/stat.c'; fi`
+
+libsysrq_lcrso-sysrq.o: sysrq.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libsysrq_lcrso_CFLAGS) $(CFLAGS) -MT libsysrq_lcrso-sysrq.o -MD -MP -MF $(DEPDIR)/libsysrq_lcrso-sysrq.Tpo -c -o libsysrq_lcrso-sysrq.o `test -f 'sysrq.c' || echo '$(srcdir)/'`sysrq.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libsysrq_lcrso-sysrq.Tpo $(DEPDIR)/libsysrq_lcrso-sysrq.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='sysrq.c' object='libsysrq_lcrso-sysrq.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libsysrq_lcrso_CFLAGS) $(CFLAGS) -c -o libsysrq_lcrso-sysrq.o `test -f 'sysrq.c' || echo '$(srcdir)/'`sysrq.c
+
+libsysrq_lcrso-sysrq.obj: sysrq.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libsysrq_lcrso_CFLAGS) $(CFLAGS) -MT libsysrq_lcrso-sysrq.obj -MD -MP -MF $(DEPDIR)/libsysrq_lcrso-sysrq.Tpo -c -o libsysrq_lcrso-sysrq.obj `if test -f 'sysrq.c'; then $(CYGPATH_W) 'sysrq.c'; else $(CYGPATH_W) '$(srcdir)/sysrq.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/libsysrq_lcrso-sysrq.Tpo $(DEPDIR)/libsysrq_lcrso-sysrq.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='sysrq.c' object='libsysrq_lcrso-sysrq.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libsysrq_lcrso_CFLAGS) $(CFLAGS) -c -o libsysrq_lcrso-sysrq.obj `if test -f 'sysrq.c'; then $(CYGPATH_W) 'sysrq.c'; else $(CYGPATH_W) '$(srcdir)/sysrq.c'; fi`
+
+ID: $(am__tagged_files)
+	$(am__define_uniq_tagged_files); mkid -fID $$unique
+tags: tags-am
+TAGS: tags
+
+tags-am: $(TAGS_DEPENDENCIES) $(am__tagged_files)
+	set x; \
+	here=`pwd`; \
+	$(am__define_uniq_tagged_files); \
+	shift; \
+	if test -z "$(ETAGS_ARGS)$$*$$unique"; then :; else \
+	  test -n "$$unique" || unique=$$empty_fix; \
+	  if test $$# -gt 0; then \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      "$$@" $$unique; \
+	  else \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      $$unique; \
+	  fi; \
+	fi
+ctags: ctags-am
+
+CTAGS: ctags
+ctags-am: $(TAGS_DEPENDENCIES) $(am__tagged_files)
+	$(am__define_uniq_tagged_files); \
+	test -z "$(CTAGS_ARGS)$$unique" \
+	  || $(CTAGS) $(CTAGSFLAGS) $(AM_CTAGSFLAGS) $(CTAGS_ARGS) \
+	     $$unique
+
+GTAGS:
+	here=`$(am__cd) $(top_builddir) && pwd` \
+	  && $(am__cd) $(top_srcdir) \
+	  && gtags -i $(GTAGS_ARGS) "$$here"
+cscopelist: cscopelist-am
+
+cscopelist-am: $(am__tagged_files)
+	list='$(am__tagged_files)'; \
+	case "$(srcdir)" in \
+	  [\\/]* | ?:[\\/]*) sdir="$(srcdir)" ;; \
+	  *) sdir=$(subdir)/$(srcdir) ;; \
+	esac; \
+	for i in $$list; do \
+	  if test -f "$$i"; then \
+	    echo "$(subdir)/$$i"; \
+	  else \
+	    echo "$$sdir/$$i"; \
+	  fi; \
+	done >> $(top_builddir)/cscope.files
+
+distclean-tags:
+	-rm -f TAGS ID GTAGS GRTAGS GSYMS GPATH tags
+
+distdir: $(DISTFILES)
+	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	list='$(DISTFILES)'; \
+	  dist_files=`for file in $$list; do echo $$file; done | \
+	  sed -e "s|^$$srcdirstrip/||;t" \
+	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
+	case $$dist_files in \
+	  */*) $(MKDIR_P) `echo "$$dist_files" | \
+			   sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
+			   sort -u` ;; \
+	esac; \
+	for file in $$dist_files; do \
+	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
+	  if test -d $$d/$$file; then \
+	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d "$(distdir)/$$file"; then \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
+	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
+	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
+	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
+	  else \
+	    test -f "$(distdir)/$$file" \
+	    || cp -p $$d/$$file "$(distdir)/$$file" \
+	    || exit 1; \
+	  fi; \
+	done
+check-am: all-am
+check: check-am
+all-am: Makefile $(PROGRAMS)
+installdirs:
+	for dir in "$(DESTDIR)$(cpuinfo_sodir)" "$(DESTDIR)$(meminfo_sodir)" "$(DESTDIR)$(stat_sodir)" "$(DESTDIR)$(sysrq_sodir)"; do \
+	  test -z "$$dir" || $(MKDIR_P) "$$dir"; \
+	done
+install: install-am
+install-exec: install-exec-am
+install-data: install-data-am
+uninstall: uninstall-am
+
+install-am: all-am
+	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
+
+installcheck: installcheck-am
+install-strip:
+	if test -z '$(STRIP)'; then \
+	  $(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	    install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
+	      install; \
+	else \
+	  $(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	    install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
+	    "INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'" install; \
+	fi
+mostlyclean-generic:
+
+clean-generic:
+
+distclean-generic:
+	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
+
+maintainer-clean-generic:
+	@echo "This command is intended for maintainers to use"
+	@echo "it deletes files that may require special tools to rebuild."
+clean: clean-am
+
+clean-am: clean-cpuinfo_soPROGRAMS clean-generic \
+	clean-meminfo_soPROGRAMS clean-stat_soPROGRAMS \
+	clean-sysrq_soPROGRAMS mostlyclean-am
+
+distclean: distclean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+distclean-am: clean-am distclean-compile distclean-generic \
+	distclean-tags
+
+dvi: dvi-am
+
+dvi-am:
+
+html: html-am
+
+html-am:
+
+info: info-am
+
+info-am:
+
+install-data-am: install-cpuinfo_soPROGRAMS install-meminfo_soPROGRAMS \
+	install-stat_soPROGRAMS install-sysrq_soPROGRAMS
+
+install-dvi: install-dvi-am
+
+install-dvi-am:
+
+install-exec-am:
+
+install-html: install-html-am
+
+install-html-am:
+
+install-info: install-info-am
+
+install-info-am:
+
+install-man:
+
+install-pdf: install-pdf-am
+
+install-pdf-am:
+
+install-ps: install-ps-am
+
+install-ps-am:
+
+installcheck-am:
+
+maintainer-clean: maintainer-clean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+maintainer-clean-am: distclean-am maintainer-clean-generic
+
+mostlyclean: mostlyclean-am
+
+mostlyclean-am: mostlyclean-compile mostlyclean-generic
+
+pdf: pdf-am
+
+pdf-am:
+
+ps: ps-am
+
+ps-am:
+
+uninstall-am: uninstall-cpuinfo_soPROGRAMS \
+	uninstall-meminfo_soPROGRAMS uninstall-stat_soPROGRAMS \
+	uninstall-sysrq_soPROGRAMS
+
+.MAKE: install-am install-strip
+
+.PHONY: CTAGS GTAGS TAGS all all-am check check-am clean \
+	clean-cpuinfo_soPROGRAMS clean-generic \
+	clean-meminfo_soPROGRAMS clean-stat_soPROGRAMS \
+	clean-sysrq_soPROGRAMS cscopelist-am ctags ctags-am distclean \
+	distclean-compile distclean-generic distclean-tags distdir dvi \
+	dvi-am html html-am info info-am install install-am \
+	install-cpuinfo_soPROGRAMS install-data install-data-am \
+	install-dvi install-dvi-am install-exec install-exec-am \
+	install-html install-html-am install-info install-info-am \
+	install-man install-meminfo_soPROGRAMS install-pdf \
+	install-pdf-am install-ps install-ps-am \
+	install-stat_soPROGRAMS install-strip install-sysrq_soPROGRAMS \
+	installcheck installcheck-am installdirs maintainer-clean \
+	maintainer-clean-generic mostlyclean mostlyclean-compile \
+	mostlyclean-generic pdf pdf-am ps ps-am tags tags-am uninstall \
+	uninstall-am uninstall-cpuinfo_soPROGRAMS \
+	uninstall-meminfo_soPROGRAMS uninstall-stat_soPROGRAMS \
+	uninstall-sysrq_soPROGRAMS
+
+
+# Tell versions [3.59,3.63) of GNU make to not export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:
diff --git a/lcrso/cpuinfo.c b/lcrso/cpuinfo.c
new file mode 100644
index 0000000..f1ecd32
--- /dev/null
+++ b/lcrso/cpuinfo.c
@@ -0,0 +1,279 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <sys/param.h>
+#include <unistd.h>
+#include <fuse.h>
+#include <procfs.h>
+#include <cgroup.h>
+
+#define CACHE_SIZE 65536
+
+struct cpuinfo_private_data 
+{
+	char *cache;
+	off_t cache_len;
+};
+
+static char cpuinfo_prefix[MAXPATHLEN];
+static struct mirror_ops cpuinfo_ops;
+
+static int refresh_cpumask (struct procfs_info *fsinfo)
+{
+	char cgcpupath[MAXPATHLEN];
+	int ret = 0;
+	int index = 0;
+	int fd;
+	int len = 0;
+	char cpus_value[128];
+	// build up the bitmask of what cpus we are allowed to see. 
+	// need to parse the format of cpuset.cpus.
+	// if cpuset.cpus is longer than 255 characters, we'll miss some. 
+	memset(cpus_value, 0, 128);
+	memset(cgcpupath, 0, MAXPATHLEN);
+	//memcpy(cpus_value, "10-15",5);
+	len = strlen(cpuinfo_ops.priv_data);
+
+	if ( len > 0 && len <MAXPATHLEN )
+	{
+		strncpy(cgcpupath, cpuinfo_ops.priv_data, sizeof(cgcpupath));
+		strncpy(cgcpupath+len,"/cpuset.cpus",MAXPATHLEN-len);
+
+		fd = open(cgcpupath, O_RDONLY);
+		if(fd < 0)
+			return -1;
+		ret = read(fd, cpus_value, len);			
+		if (ret < 0)
+		{
+			close(fd);
+			return -1;
+		}	
+		close(fd);     	
+	}
+
+	//lxc_cgroup_get("cc", "cpuset.cpus", cpus_value, 128, "/usr/local/var/lib/lxc");
+
+	memset (fsinfo->cpumask, 0, 1024);
+
+	// parse cpu string. e.g. 1,3,5-10,12,15-23 
+	{
+		char in_range;
+		int c,done,i,j,k;
+		int start_range;
+		char number[10];
+
+		done=0;
+		i=0;
+		in_range=0;
+		start_range=0;
+
+		memset(number, 0, 10);
+LOOP:	     
+		while (!done)
+		{
+			c = cpus_value[index];
+			switch (c)
+			{
+				case '0' ... '9':
+					number[i++] = c;
+					break;
+				case 0:
+					done=1;
+					goto LOOP;
+					//		       break;
+				case '\n':
+				case ',':
+					i=0;
+					j=atoi(number);
+					if (in_range)
+					{
+						for (k=start_range;k<=j;k++)
+						{
+							fsinfo->cpumask[k]=1;
+						}
+					}
+					else 
+					{
+						fsinfo->cpumask[j]=1;
+					}
+					memset(number,0,10);
+					in_range=0;
+					break;
+				case '-':
+					i=0;
+					j=atoi(number);
+					memset(number,0,10);
+					start_range=j;
+					in_range=1;
+					break;
+				default:
+					i=0;
+					in_range=0;
+			} 
+			++index;
+		}
+	}// parser
+
+	return ret;     
+}
+
+
+
+static int cpuinfo_open(const char *path, struct fuse_file_info *fi)
+{
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	pfile->file.mirror.data = NULL;
+
+	return 0;
+}
+
+static int cpuinfo_read(const char *path, char *buf, size_t size,
+		off_t offset, struct fuse_file_info *fi) 
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	struct cpuinfo_private_data *cpuinfo_private_data = pfile->file.mirror.data;
+
+	char buffer[1024];
+	size_t len = 0;
+    int ret = 0;
+	int printing = 0;
+	size_t my_size = 0;
+	FILE *underlying = NULL;
+
+	// clear out the return buffer. fuse will ask us for the data a couple of times.
+	refresh_cpumask(fsinfo);
+	memset(buf, 0, size);
+
+    if (cpuinfo_private_data == NULL ) {
+        cpuinfo_private_data = malloc(sizeof(*cpuinfo_private_data));
+        if (!cpuinfo_private_data) {
+            goto out;
+        }
+
+        memset(cpuinfo_private_data, 0, sizeof(*cpuinfo_private_data));
+
+        cpuinfo_private_data->cache = malloc(CACHE_SIZE);
+
+        if (cpuinfo_private_data->cache == NULL) {
+            free(cpuinfo_private_data->cache);
+            goto out;	
+        }
+
+        memset(cpuinfo_private_data->cache , 0 , CACHE_SIZE);
+        pfile->file.mirror.data = cpuinfo_private_data;
+
+        underlying = fdopen(dup(pfile->file.mirror.fd),"r");
+        if (!underlying) {
+            goto out;
+        }
+
+        fseek(underlying,0,SEEK_SET);
+        memset (buffer, 0, 1024);
+
+        // we must be careful to not exceed the size + offset
+        while (fgets(buffer, 1023, underlying) != NULL) {
+            int proc_id;
+            int blen;
+
+            blen = strlen(buffer);
+
+            // interstanza reset.
+            if ('\n' == *buffer) {
+                if (printing){ 
+                    ret = snprintf(cpuinfo_private_data->cache+len, CACHE_SIZE - len,"\n");
+                    if(ret > 0){
+                        if(len + ret < CACHE_SIZE){
+                            len += ret;
+                        }else{
+                            len = CACHE_SIZE - 1;
+                        }
+                    }
+                }
+                printing=0;
+            }
+
+            if (0 == strncmp(buffer,"processor",9)) {
+                proc_id=0;
+                int j ;
+                for (j=0;j<blen;j++) {
+                    if (buffer[j] == ':') 
+                        proc_id=atoi(buffer+j+1);
+                }
+
+                if (1 == fsinfo->cpumask[proc_id]) 
+                    printing=1; 
+                else 
+                    printing=0;
+            }
+            if (printing){ 
+                ret = snprintf(cpuinfo_private_data->cache+len, CACHE_SIZE - len,"%s",buffer);
+                if(ret > 0){
+                        if(len + ret < CACHE_SIZE){
+                                len += ret;
+                        }else{
+                                len = CACHE_SIZE - 1;
+                        }
+                }
+            }
+        }
+
+        fclose(underlying);
+        cpuinfo_private_data->cache_len = len;
+    }
+
+     // return the data. 
+	if (cpuinfo_private_data->cache_len > 0) {
+		my_size=size;
+		if ((offset+size) > cpuinfo_private_data->cache_len) 
+			my_size = cpuinfo_private_data->cache_len - offset;
+		if (offset >= cpuinfo_private_data->cache_len)  
+			my_size = 0;
+
+		if (my_size > 0) {
+			memcpy(buf,cpuinfo_private_data->cache+offset,my_size);
+        } else {
+            if (cpuinfo_private_data->cache != NULL){
+                free(cpuinfo_private_data->cache);
+                cpuinfo_private_data->cache = NULL;
+            }
+            free(cpuinfo_private_data);
+            cpuinfo_private_data = NULL;
+            pfile->file.mirror.data = NULL;
+        }
+	}
+
+out:
+	return my_size;
+}
+
+static int cpuinfo_release(const char *path, struct fuse_file_info *fi) 
+{     
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	struct cpuinfo_private_data *cpuinfo_private_data = pfile->file.mirror.data;
+
+    if (cpuinfo_private_data != NULL){
+        if (cpuinfo_private_data->cache != NULL){
+            free(cpuinfo_private_data->cache);
+            cpuinfo_private_data->cache = NULL;
+        }
+        free(cpuinfo_private_data);
+    }
+
+	return 0;
+}
+ 
+static struct mirror_ops cpuinfo_ops = {
+	.name 	 = "cpuinfo",
+	.open 	 = cpuinfo_open,
+	.read	 = cpuinfo_read,
+	.release = cpuinfo_release,
+	.priv_data = cpuinfo_prefix,
+};
+
+__attribute__((constructor))static void procfs_component_register(void) {
+	lcr_component_register(&cpuinfo_ops);
+}
diff --git a/lcrso/meminfo.c b/lcrso/meminfo.c
new file mode 100644
index 0000000..07ebd81
--- /dev/null
+++ b/lcrso/meminfo.c
@@ -0,0 +1,231 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <sys/param.h>
+#include <unistd.h>
+#include <fuse.h>
+#include <procfs.h>
+
+struct meminfo {
+	FILE *memlimit;
+	FILE *memusage;
+	FILE *swaplimit;
+	FILE *swapusage;
+};
+
+static struct mirror_ops meminfo_ops;
+static char meminfo_prefix[MAXPATHLEN];
+
+static int meminfo_open(const char *path, struct fuse_file_info *fi)
+{
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	char cgmntpath[MAXPATHLEN];
+	char cgpath[MAXPATHLEN];
+	char *cgname;
+	struct meminfo *meminfo;
+	int ret;
+
+	if (get_cgroup_mount("/etc/mtab", cgmntpath))
+		if (get_cgroup_mount("/proc/mounts", cgmntpath))
+			return -ENOENT;
+
+	cgname = cgroup_name();
+	if (!cgname) {
+		return -errno;
+	}
+ 
+ 	meminfo = malloc(sizeof(*meminfo));
+	if (!meminfo) {
+		ret = -ENOMEM;
+		goto out;
+	}
+	memset(meminfo, 0, sizeof(*meminfo));
+
+	pfile->file.mirror.data = meminfo;
+
+	ret = -ENOENT;
+
+	if ('\0' != *(char *)meminfo_ops.priv_data) {
+		strncpy(cgmntpath, meminfo_ops.priv_data, sizeof(cgmntpath));
+	}
+	snprintf(cgpath, sizeof(cgpath), "%s/memory.limit_in_bytes", cgmntpath);
+	meminfo->memlimit = fopen(cgpath, "r");
+	if (!meminfo->memlimit)
+		goto out_free_meminfo;
+
+	snprintf(cgpath, sizeof(cgpath), "%s/memory.usage_in_bytes", cgmntpath);
+	meminfo->memusage = fopen(cgpath, "r");
+	if (!meminfo->memusage)
+		goto out_close_memlimit;
+
+	setvbuf(meminfo->memusage, NULL, _IONBF, 0);
+
+	snprintf(cgpath, sizeof(cgpath), "%s/memory.memsw.limit_in_bytes", cgmntpath);
+	meminfo->swaplimit = fopen(cgpath, "r");
+	if (!meminfo->swaplimit)
+		goto out_close_memusage;
+
+	snprintf(cgpath, sizeof(cgpath), "%s%s/memory.memsw.usage_in_bytes", cgmntpath, cgname);
+	meminfo->swapusage = fopen(cgpath, "r");
+	if (!meminfo->swapusage)
+		goto out_close_swaplimit;
+	setvbuf(meminfo->swapusage, NULL, _IONBF, 0);
+
+	ret = 0;
+out:
+	free(cgname);
+	return ret;
+
+out_close_swaplimit:
+	fclose(meminfo->swaplimit);
+out_close_memusage:
+	fclose(meminfo->memusage);
+out_close_memlimit:
+	fclose(meminfo->memlimit);
+out_free_meminfo:
+	free(meminfo);
+	pfile->file.mirror.data = NULL;
+	goto out;
+}
+
+static int meminfo_read(const char *path, char *buf, size_t size,
+			off_t offset, struct fuse_file_info *fi)
+{
+    struct procfs_file *pfile = (typeof(pfile))fi->fh;
+    struct meminfo *meminfo = pfile->file.mirror.data;
+    long long memlimit, memusage, swaplimit, swapusage;
+    long long swap_free_kb = 0, total_limit_kb = 0, swap_limit_kb = 0; /* These are for the underlying */
+    FILE *underlying;
+    char buffer[256];
+    size_t len;
+
+    if (offset)
+        return 0;
+
+    if (!meminfo  
+            || !meminfo->memlimit
+            || !meminfo->memusage
+            || !meminfo->swaplimit
+            || !meminfo->swapusage){
+        return -ENOENT;
+    }
+
+    memset(buf, 0, size);
+
+    underlying = fdopen(dup(pfile->file.mirror.fd),"r");
+    if(underlying == NULL){
+        perror("underlying is NULL:");
+        goto err;
+    }
+
+    fseek(underlying,0,SEEK_SET);
+    memset (buffer, 0, 256);
+
+    while (fgets(buffer, 255, underlying) != NULL) {
+        if (0 == strncmp(buffer,"MemTotal:",9)) {
+            total_limit_kb = strtoul(buffer+9,NULL,10);
+        }
+        if (0 == strncmp(buffer,"SwapTotal:",10)) {
+            swap_limit_kb = strtoul(buffer+10,NULL,10);
+        }
+        if (0 == strncmp(buffer,"SwapFree:",9)) {
+            swap_free_kb = strtoul(buffer+9,NULL,10);
+        }
+    }
+    fclose(underlying);
+
+    fseek(meminfo->memlimit, 0, SEEK_SET);
+    fscanf(meminfo->memlimit, "%lld", &memlimit);
+    if(ferror(meminfo->memlimit)){
+        goto err;
+    }
+
+    fseek(meminfo->memusage, 0, SEEK_SET);
+    fscanf(meminfo->memusage, "%lld", &memusage);
+    if(ferror(meminfo->memusage)){
+        goto err;
+    }
+
+    fseek(meminfo->swaplimit, 0, SEEK_SET);
+    fscanf(meminfo->swaplimit, "%lld", &swaplimit);
+    if(ferror(meminfo->swaplimit)){
+        goto err;
+    }
+
+    fseek(meminfo->swapusage, 0, SEEK_SET);
+    fscanf(meminfo->swapusage, "%lld", &swapusage);
+    if(ferror(meminfo->swapusage)){
+        goto err;
+    }
+
+    if ( (memlimit >> 10) > total_limit_kb) memlimit = total_limit_kb << 10;
+    if ( (swaplimit >> 10) > swap_limit_kb) swaplimit = swap_limit_kb << 10;
+    if ((swaplimit >> 10) > swap_free_kb) swaplimit = swap_free_kb << 10;
+
+    len = 0;
+	len = snprintf(buf, size, 
+			"MemTotal:       %8lld kB\n"
+			"MemFree:        %8lld kB\n"
+			"SwapTotal:      %8lld kB\n"
+			"SwapFree:       %8lld kB\n",
+			memlimit >> 10,
+			(memlimit - memusage) >> 10,
+			(swaplimit > 0) ? swaplimit : 0 >> 10,
+			(swaplimit > swapusage) ? (swaplimit - swapusage) : 0 >> 10);
+
+	if(len < 0 || len >= size){
+        return 0;
+    }
+
+    return len;
+err:
+    return -EAGAIN;
+}
+
+static int meminfo_release(const char *path, struct fuse_file_info *fi)
+{
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	struct meminfo *meminfo = NULL;
+	if(!pfile){
+		return 0;
+	}
+
+	meminfo = pfile->file.mirror.data;
+	if(!meminfo){
+		return 0;
+	}
+
+	if(meminfo->memlimit){
+		fclose(meminfo->memlimit);
+	}
+
+	if(meminfo->memusage){
+		fclose(meminfo->memusage);
+	}
+
+	if(meminfo->swaplimit){
+		fclose(meminfo->swaplimit);
+	}
+
+	if(meminfo->swapusage){
+		fclose(meminfo->swapusage);
+	}
+
+	free(meminfo);
+	pfile->file.mirror.data = NULL;
+
+	return 0;
+}
+
+static struct mirror_ops meminfo_ops = {
+	.name 	= "meminfo",
+	.open    = meminfo_open,
+	.read    = meminfo_read,
+	.release = meminfo_release,
+	.priv_data = meminfo_prefix,
+};
+
+__attribute__((constructor))static void procfs_component_register(void) {
+	lcr_component_register(&meminfo_ops);
+}
diff --git a/lcrso/stat.c b/lcrso/stat.c
new file mode 100644
index 0000000..c13d462
--- /dev/null
+++ b/lcrso/stat.c
@@ -0,0 +1,411 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <unistd.h>
+#include <sys/param.h>
+#include <fuse.h>
+#include <procfs.h>
+
+#define CPU_MAX	128
+#define CACHE_SIZE 65536
+
+struct stat_private_data
+{
+     char *cache;
+     off_t cache_len;
+};
+
+struct stat_file {
+	FILE *cpuacct_usage_percpu;
+	FILE *cpuacct_stat;
+	FILE *cpuacct_stat_percpu;
+};
+
+static struct mirror_ops stat_ops;
+static char stat_prefix[MAXPATHLEN];
+static struct stat_file stat_file;
+
+static int stat_refresh_cpumask (struct procfs_info *fsinfo)
+{
+	char cgcpupath[MAXPATHLEN];
+	int ret = 0;
+	int index = 0;
+	int fd;
+	int len = 0;
+	char cpus_value[128];
+	// build up the bitmask of what cpus we are allowed to see. 
+	// need to parse the format of cpuset.cpus.
+	// if cpuset.cpus is longer than 255 characters, we'll miss some. 
+	memset(cpus_value, 0, 128);
+	memset(cgcpupath, 0, MAXPATHLEN);
+	//memcpy(cpus_value, "10-15",5);
+	len = strlen(stat_ops.priv_data+2000);
+
+	if ( len > 0 && len <MAXPATHLEN )
+	{
+		strncpy(cgcpupath, stat_ops.priv_data+2000, sizeof(cgcpupath));
+		strncpy(cgcpupath+len,"/cpuset.cpus",MAXPATHLEN-len);
+
+		fd = open(cgcpupath, O_RDONLY);
+		if(fd < 0)
+			return -1;
+		ret = read(fd, cpus_value, len);			
+		if (ret < 0)
+		{
+			close(fd);
+			return -1;
+		}	
+		close(fd);     	
+	}
+
+	//lxc_cgroup_get("cc", "cpuset.cpus", cpus_value, 128, "/usr/local/var/lib/lxc");
+
+	memset (fsinfo->cpumask, 0, 1024);
+
+	// parse cpu string. e.g. 1,3,5-10,12,15-23 
+	{
+		char in_range;
+		int c,done,i,j,k;
+		int start_range;
+		char number[10];
+
+		done=0;
+		i=0;
+		in_range=0;
+		start_range=0;
+
+		memset(number, 0, 10);
+LOOP:	     
+		while (!done)
+		{
+			c = cpus_value[index];
+			switch (c)
+			{
+				case '0' ... '9':
+					number[i++] = c;
+					break;
+				case 0:
+					done=1;
+					goto LOOP;
+					//		       break;
+				case '\n':
+				case ',':
+					i=0;
+					j=atoi(number);
+					if (in_range)
+					{
+						for (k=start_range;k<=j;k++)
+						{
+							fsinfo->cpumask[k]=1;
+						}
+					}
+					else 
+					{
+						fsinfo->cpumask[j]=1;
+					}
+					memset(number,0,10);
+					in_range=0;
+					break;
+				case '-':
+					i=0;
+					j=atoi(number);
+					memset(number,0,10);
+					start_range=j;
+					in_range=1;
+					break;
+				default:
+					i=0;
+					in_range=0;
+			} 
+			++index;
+		}
+	}// parser
+
+	return ret;     
+}
+
+static void idle_change(char *head, unsigned long long idle) {
+	int blank_left = 5;
+	char *p = head;
+	int len = 0;
+
+	if( strncmp(head , "cpu" , 3) == 0 ) {
+		while (*p && blank_left) {
+			if (*p++ == ' ')
+				--blank_left;
+		}
+
+		len = sprintf(p, "%llu", idle);
+		while (p[len] != ' ')
+			p[len++] = ' ';
+	}
+}
+
+static int stat_open(const char *path, struct fuse_file_info *fi)
+{
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+
+	pfile->file.mirror.data = NULL;
+
+	if (stat_file.cpuacct_stat == NULL) {
+		char cgmntpath[MAXPATHLEN];
+		if (strlen(stat_ops.priv_data) > 0) {
+			strncpy(cgmntpath, stat_ops.priv_data, sizeof(cgmntpath));
+		} 
+		strncat(cgmntpath, "/cpuacct.stat", sizeof(cgmntpath));
+		stat_file.cpuacct_stat = fopen(cgmntpath, "r");
+		if (stat_file.cpuacct_stat == NULL)
+			return -ENOENT;
+
+		setvbuf(stat_file.cpuacct_stat, NULL, _IONBF, 0);
+	}
+
+	if (stat_file.cpuacct_usage_percpu == NULL) {
+		char cgmntpath[MAXPATHLEN];
+		if (strlen(stat_ops.priv_data) > 0) {
+			strncpy(cgmntpath, stat_ops.priv_data, sizeof(cgmntpath));
+		} 
+		strncat(cgmntpath, "/cpuacct.usage_percpu", sizeof(cgmntpath));
+		stat_file.cpuacct_usage_percpu = fopen(cgmntpath, "r");
+		if (stat_file.cpuacct_usage_percpu == NULL)
+			return -ENOENT;
+
+		setvbuf(stat_file.cpuacct_usage_percpu, NULL, _IONBF, 0);
+	}
+
+	if (stat_file.cpuacct_stat_percpu == NULL) {
+		char cgmntpath[MAXPATHLEN];
+		if (strlen(stat_ops.priv_data) > 0) {
+			strncpy(cgmntpath, stat_ops.priv_data, sizeof(cgmntpath));
+		} 
+		strncat(cgmntpath, "/cpuacct.stat_percpu", sizeof(cgmntpath));
+		stat_file.cpuacct_stat_percpu = fopen(cgmntpath, "r");
+
+		if (stat_file.cpuacct_stat_percpu != NULL)
+			setvbuf(stat_file.cpuacct_stat_percpu, NULL, _IONBF, 0);
+	}
+
+	return 0;
+}
+
+static int stat_read(const char *path, char *buf, size_t size,
+		off_t offset, struct fuse_file_info *fi) 
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	struct stat_private_data *stat_private_data = pfile->file.mirror.data;
+
+	FILE *underlying;
+
+	// intr line can be long. On the dl580 its 2380 with fc12
+	char buffer[10240];
+	size_t len = 0;
+	size_t my_size = 0;
+	int ncpu = 0;
+	int res = 0;
+	unsigned long long user, nice, system, idle, iowait, irq, softirq, steal;
+	unsigned long long ustick[CPU_MAX], nitick[CPU_MAX], sytick[CPU_MAX],  hitick[CPU_MAX], sitick[CPU_MAX];
+
+	stat_refresh_cpumask(fsinfo);
+	user = nice = system = idle = iowait= irq = softirq = steal = 0;
+
+	if (stat_file.cpuacct_stat != NULL) {
+		char line[1024];
+		fseek(stat_file.cpuacct_stat, 0, SEEK_SET);
+		while (fgets(line, sizeof(line), stat_file.cpuacct_stat)) {
+			if (strncmp(line, "user", 4) == 0) {
+				user = atoll(line + 5);
+			}else if (strncmp(line, "system", 6) == 0) {
+				system = atoll(line + 7);
+			}
+		}	
+	}
+
+	if (stat_file.cpuacct_stat_percpu != NULL) {
+		char line[4096];
+		int index;
+		memset(ustick, 0, sizeof(ustick));
+		memset(nitick, 0, sizeof(nitick));
+		memset(sytick, 0, sizeof(sytick));
+		memset(hitick, 0, sizeof(hitick));
+		memset(sitick, 0, sizeof(sitick));
+		fseek(stat_file.cpuacct_stat_percpu, 0, SEEK_SET);
+
+		while (fgets(line, sizeof(line), stat_file.cpuacct_stat_percpu)) {
+			if (line[3] == ' ') {
+				continue;
+			} else {
+				ncpu = atoi(line + 3);
+			}
+
+			sscanf(line, "cpu%d %llu %llu %llu %llu %llu\n", &index, &ustick[ncpu], &nitick[ncpu], &sytick[ncpu], &hitick[ncpu], &sitick[ncpu]);
+		}
+	} else if (stat_file.cpuacct_usage_percpu != NULL) {
+		memset(ustick, 0, sizeof(ustick));
+		fseek(stat_file.cpuacct_usage_percpu, 0, SEEK_SET);
+		while (1) {
+			res = fscanf(stat_file.cpuacct_usage_percpu, "%llu", &ustick[ncpu]);
+			ustick[ncpu] /= 1000000;
+			if (res < 1) 
+				break;
+			++ncpu;
+		}
+	}
+
+	// clear out the return buffer. fuse will ask us for the data a couple of times.
+	memset(buf, 0, size);
+
+	if ( stat_private_data == NULL ) {
+		stat_private_data = malloc(sizeof(struct stat_private_data));
+		if (stat_private_data == NULL) {
+			goto out;
+		}
+
+		memset (stat_private_data, 0, sizeof(struct stat_private_data));
+
+		stat_private_data->cache = malloc(CACHE_SIZE);
+		if (stat_private_data->cache == NULL) {
+			free(stat_private_data);
+			goto out;
+		}
+
+		memset (stat_private_data->cache, 0, CACHE_SIZE);
+		pfile->file.mirror.data = stat_private_data;
+
+		underlying = fdopen(dup(pfile->file.mirror.fd),"r");
+		if (!underlying) {
+			goto out;
+		}
+
+		fseek(underlying,0,SEEK_SET);
+		memset (buffer, 0, 10240);
+
+		// we must be careful to not exceed the size + offset
+		while (fgets(buffer, 10239, underlying) != NULL) {
+			int proc_id;
+			unsigned long long u1, u2, u3, u4, u5, u6, u7, u8, u9;
+			char str[10240];
+			int i;
+			int iret;
+			iret = 0;
+
+			buffer[10239] = '\0';
+
+			if (0==strncmp(buffer,"cpu",3)){
+				switch (*(buffer+3))
+				{		
+					case ' ': {
+								  sscanf(buffer, "cpu  %llu %llu %llu %llu %llu %llu %llu %llu %llu\n", &u1, &u2, &u3, &u4, &u5, &u6, &u7, &u8, &u9);
+								  iret = snprintf(str, sizeof(str), "cpu  %llu %llu %llu %llu %llu %llu %llu %llu %llu\n", user, u2, system, u4, u5, u6, u7, u8, u9);
+								  if(iret <= 0){
+									  break;
+								  }
+
+								  if(iret > sizeof(str) - 1){
+									  iret = sizeof(str) - 1;
+								  }
+								  if(len + iret < CACHE_SIZE){
+									  len += snprintf(stat_private_data->cache+len, CACHE_SIZE - len,"%s",str);
+								  }
+								  break;
+							  }
+							  // gnu extension for the lazy 
+					case '0' ... '9':
+							  sscanf(buffer, "cpu%d  %llu %llu %llu %llu %llu %llu %llu %llu %llu\n",&i, &u1, &u2, &u3, &u4, &u5, &u6, &u7, &u8, &u9);
+							  proc_id = 0;
+							  proc_id = atoi(buffer+3);
+							  if (1 == fsinfo->cpumask[proc_id]) {
+								  u1 = ustick[proc_id];
+								  idle += u4;
+								  if (stat_file.cpuacct_stat_percpu != NULL) { 
+									  u2 = nitick[proc_id];
+									  u3 = sytick[proc_id];
+									  u6 = hitick[proc_id];
+									  u7 = sitick[proc_id]; 
+								  }
+								  iret = snprintf(str, sizeof(str), "cpu%d  %llu %llu %llu %llu %llu %llu %llu %llu %llu\n", i, u1, u2, u3, u4, u5, u6, u7, u8, u9);
+								  if(iret > 0){
+									  if(iret > sizeof(str) - 1){
+										  iret = sizeof(str) - 1;
+									  }
+									  if(len + iret < CACHE_SIZE){
+										  len += snprintf(stat_private_data->cache+len, CACHE_SIZE - len,"%s",str);
+									  }
+								  }
+
+							  }
+							  break;
+					default:
+							  break;
+				}
+			} else {
+				// just pass the remainder through for the time being.
+				iret = snprintf(stat_private_data->cache+len, CACHE_SIZE - len,"%s",buffer);
+				if(len + iret < CACHE_SIZE){
+					len += iret;
+				}else{
+					len = CACHE_SIZE - 1;
+				}
+			}
+		}
+
+		fclose(underlying);
+		stat_private_data->cache_len = len;
+		idle_change(stat_private_data->cache, idle);
+	}
+
+	// return the data. 
+	if (stat_private_data->cache_len > 0) {
+		my_size=size;
+		if ((offset+size) > stat_private_data->cache_len) 
+			my_size = stat_private_data->cache_len - offset;
+		if (offset >= stat_private_data->cache_len)  
+			my_size = 0;
+
+		if (my_size > 0) { 
+			memcpy(buf,stat_private_data->cache+offset,my_size);
+		} else {
+			if (stat_private_data->cache != NULL) {
+				free(stat_private_data->cache);
+				stat_private_data->cache = NULL;
+			}
+			free(stat_private_data);
+			stat_private_data = NULL;
+			pfile->file.mirror.data = NULL;
+		}
+	}
+
+out:
+	return my_size;
+}
+
+static int stat_release(const char *path, struct fuse_file_info *fi) 
+{     
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+	struct stat_private_data *stat_private_data = pfile->file.mirror.data;
+
+	if (stat_private_data != NULL) {
+		if (stat_private_data->cache != NULL){
+			free(stat_private_data->cache);
+			stat_private_data->cache = NULL;
+		}
+		free(stat_private_data);
+	}
+
+	return 0;
+}
+
+static struct mirror_ops stat_ops = {
+	.name 	 = "stat",
+	.open 	 = stat_open,
+	.read	 = stat_read,
+	.release = stat_release,
+	.priv_data = stat_prefix,
+};
+
+__attribute__((constructor))static void stat_component_register(void) {
+	lcr_component_register(&stat_ops);
+}
diff --git a/lcrso/sysrq.c b/lcrso/sysrq.c
new file mode 100644
index 0000000..7796218
--- /dev/null
+++ b/lcrso/sysrq.c
@@ -0,0 +1,38 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <unistd.h>
+#include <fuse.h>
+#include <procfs.h>
+
+static int sysrq_open(const char *path, struct fuse_file_info *fi)
+{
+	int ret = 0;
+
+	return ret;
+}
+
+static int sysrq_read(const char *path, char *buf, size_t size,
+			off_t offset, struct fuse_file_info *fi) 
+{
+	size_t my_size = 0;
+
+	return my_size;
+}
+
+static int sysrq_release(const char *path, struct fuse_file_info *fi) 
+{    
+	return 0;
+}
+
+struct mirror_ops sysrq_ops = {
+	.name 	 = "sysrq-trigger",
+	.open 	 = sysrq_open,
+	.read	 = sysrq_read,
+	.release = sysrq_release,
+};
+
+__attribute__((constructor))static void stat_component_register(void) {
+	lcr_component_register(&sysrq_ops);
+}
diff --git a/src/Makefile.in b/src/Makefile.in
index bb76e35..b8b9dd1 100644
--- a/src/Makefile.in
+++ b/src/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -370,8 +370,8 @@ $(ACLOCAL_M4):  $(am__aclocal_m4_deps)
 $(am__aclocal_m4_deps):
 
 config.h: stamp-h1
-	@test -f $@ || rm -f stamp-h1
-	@test -f $@ || $(MAKE) $(AM_MAKEFLAGS) stamp-h1
+	@if test ! -f $@; then rm -f stamp-h1; else :; fi
+	@if test ! -f $@; then $(MAKE) $(AM_MAKEFLAGS) stamp-h1; else :; fi
 
 stamp-h1: $(srcdir)/config.h.in $(top_builddir)/config.status
 	@rm -f stamp-h1
diff --git a/src/config.h.in b/src/config.h.in
index e516826..32ac612 100644
--- a/src/config.h.in
+++ b/src/config.h.in
@@ -140,6 +140,9 @@
 /* Enabling mutex debugging */
 #undef MUTEX_DEBUGGING
 
+/* Define to 1 if your C compiler doesn't accept -c and -o together. */
+#undef NO_MINUS_C_MINUS_O
+
 /* Name of package */
 #undef PACKAGE
 
diff --git a/src/lua-lxc/Makefile.in b/src/lua-lxc/Makefile.in
index 9a0e3ce..01c8101 100644
--- a/src/lua-lxc/Makefile.in
+++ b/src/lua-lxc/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/src/lxc/Makefile.am b/src/lxc/Makefile.am
index 7c7c310..12ac2bc 100644
--- a/src/lxc/Makefile.am
+++ b/src/lxc/Makefile.am
@@ -20,6 +20,7 @@ noinst_HEADERS = \
 	namespace.h \
 	start.h \
 	state.h \
+	procfs.h \
 	utils.h
 
 if IS_BIONIC
@@ -56,6 +57,7 @@ liblxc_so_SOURCES = \
 	bdev.c bdev.h \
 	commands.c commands.h \
 	start.c start.h \
+	procfs.c procfs.h \
 	execute.c \
 	monitor.c monitor.h \
 	console.c \
@@ -145,14 +147,17 @@ AM_CFLAGS += -DHAVE_SECCOMP $(SECCOMP_CFLAGS)
 liblxc_so_SOURCES += seccomp.c
 endif
 
-liblxc_so_CFLAGS = -fPIC -DPIC $(AM_CFLAGS) -pthread
+liblxc_so_CFLAGS = -fPIC -DPIC $(AM_CFLAGS) -pthread 
+liblxc_so_CFLAGS += -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=27
+
 
 liblxc_so_LDFLAGS = \
 	-pthread \
 	-shared \
+	-rdynamic \
 	-Wl,-soname,liblxc.so.$(firstword $(subst ., ,$(VERSION)))
 
-liblxc_so_LDADD = $(CAP_LIBS) $(APPARMOR_LIBS) $(SELINUX_LIBS) $(SECCOMP_LIBS)
+liblxc_so_LDADD = $(CAP_LIBS) $(APPARMOR_LIBS) $(SELINUX_LIBS) $(SECCOMP_LIBS) -lfuse
 
 if ENABLE_CGMANAGER
 liblxc_so_LDADD += $(CGMANAGER_LIBS) $(DBUS_LIBS) $(NIH_LIBS) $(NIH_DBUS_LIBS)
diff --git a/src/lxc/Makefile.in b/src/lxc/Makefile.in
index 8090be2..06a22a1 100644
--- a/src/lxc/Makefile.in
+++ b/src/lxc/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
@@ -144,19 +144,20 @@ init_lxc_OBJECTS = $(am_init_lxc_OBJECTS)
 init_lxc_LDADD = $(LDADD)
 init_lxc_DEPENDENCIES = liblxc.so
 am__liblxc_so_SOURCES_DIST = arguments.c arguments.h bdev.c bdev.h \
-	commands.c commands.h start.c start.h execute.c monitor.c \
-	monitor.h console.c freezer.c error.h error.c parse.c parse.h \
-	cgfs.c cgroup.c cgroup.h lxc.h utils.c utils.h sync.c sync.h \
-	namespace.h namespace.c conf.c conf.h confile.c confile.h \
-	list.h state.c state.h log.c log.h attach.c attach.h network.c \
-	network.h nl.c nl.h rtnl.c rtnl.h genl.c genl.h caps.c caps.h \
-	lxcseccomp.h mainloop.c mainloop.h af_unix.c af_unix.h \
-	lxcutmp.c lxcutmp.h lxclock.h lxclock.c lxccontainer.c \
-	lxccontainer.h version.h lsm/nop.c lsm/lsm.h lsm/lsm.c \
-	lsm/apparmor.c lsm/selinux.c cgmanager.c ../include/ifaddrs.c \
-	../include/ifaddrs.h ../include/openpty.c ../include/openpty.h \
-	../include/lxcmntent.c ../include/lxcmntent.h \
-	../include/getline.c ../include/getline.h seccomp.c
+	commands.c commands.h start.c start.h procfs.c procfs.h \
+	execute.c monitor.c monitor.h console.c freezer.c error.h \
+	error.c parse.c parse.h cgfs.c cgroup.c cgroup.h lxc.h utils.c \
+	utils.h sync.c sync.h namespace.h namespace.c conf.c conf.h \
+	confile.c confile.h list.h state.c state.h log.c log.h \
+	attach.c attach.h network.c network.h nl.c nl.h rtnl.c rtnl.h \
+	genl.c genl.h caps.c caps.h lxcseccomp.h mainloop.c mainloop.h \
+	af_unix.c af_unix.h lxcutmp.c lxcutmp.h lxclock.h lxclock.c \
+	lxccontainer.c lxccontainer.h version.h lsm/nop.c lsm/lsm.h \
+	lsm/lsm.c lsm/apparmor.c lsm/selinux.c cgmanager.c \
+	../include/ifaddrs.c ../include/ifaddrs.h ../include/openpty.c \
+	../include/openpty.h ../include/lxcmntent.c \
+	../include/lxcmntent.h ../include/getline.c \
+	../include/getline.h seccomp.c
 am__dirstamp = $(am__leading_dot)dirstamp
 @ENABLE_APPARMOR_TRUE@am__objects_1 =  \
 @ENABLE_APPARMOR_TRUE@	lsm/liblxc_so-apparmor.$(OBJEXT)
@@ -172,22 +173,22 @@ am__objects_3 = lsm/liblxc_so-nop.$(OBJEXT) \
 @ENABLE_SECCOMP_TRUE@am__objects_7 = liblxc_so-seccomp.$(OBJEXT)
 am_liblxc_so_OBJECTS = liblxc_so-arguments.$(OBJEXT) \
 	liblxc_so-bdev.$(OBJEXT) liblxc_so-commands.$(OBJEXT) \
-	liblxc_so-start.$(OBJEXT) liblxc_so-execute.$(OBJEXT) \
-	liblxc_so-monitor.$(OBJEXT) liblxc_so-console.$(OBJEXT) \
-	liblxc_so-freezer.$(OBJEXT) liblxc_so-error.$(OBJEXT) \
-	liblxc_so-parse.$(OBJEXT) liblxc_so-cgfs.$(OBJEXT) \
-	liblxc_so-cgroup.$(OBJEXT) liblxc_so-utils.$(OBJEXT) \
-	liblxc_so-sync.$(OBJEXT) liblxc_so-namespace.$(OBJEXT) \
-	liblxc_so-conf.$(OBJEXT) liblxc_so-confile.$(OBJEXT) \
-	liblxc_so-state.$(OBJEXT) liblxc_so-log.$(OBJEXT) \
-	liblxc_so-attach.$(OBJEXT) liblxc_so-network.$(OBJEXT) \
-	liblxc_so-nl.$(OBJEXT) liblxc_so-rtnl.$(OBJEXT) \
-	liblxc_so-genl.$(OBJEXT) liblxc_so-caps.$(OBJEXT) \
-	liblxc_so-mainloop.$(OBJEXT) liblxc_so-af_unix.$(OBJEXT) \
-	liblxc_so-lxcutmp.$(OBJEXT) liblxc_so-lxclock.$(OBJEXT) \
-	liblxc_so-lxccontainer.$(OBJEXT) $(am__objects_3) \
-	$(am__objects_4) $(am__objects_5) $(am__objects_6) \
-	$(am__objects_7)
+	liblxc_so-start.$(OBJEXT) liblxc_so-procfs.$(OBJEXT) \
+	liblxc_so-execute.$(OBJEXT) liblxc_so-monitor.$(OBJEXT) \
+	liblxc_so-console.$(OBJEXT) liblxc_so-freezer.$(OBJEXT) \
+	liblxc_so-error.$(OBJEXT) liblxc_so-parse.$(OBJEXT) \
+	liblxc_so-cgfs.$(OBJEXT) liblxc_so-cgroup.$(OBJEXT) \
+	liblxc_so-utils.$(OBJEXT) liblxc_so-sync.$(OBJEXT) \
+	liblxc_so-namespace.$(OBJEXT) liblxc_so-conf.$(OBJEXT) \
+	liblxc_so-confile.$(OBJEXT) liblxc_so-state.$(OBJEXT) \
+	liblxc_so-log.$(OBJEXT) liblxc_so-attach.$(OBJEXT) \
+	liblxc_so-network.$(OBJEXT) liblxc_so-nl.$(OBJEXT) \
+	liblxc_so-rtnl.$(OBJEXT) liblxc_so-genl.$(OBJEXT) \
+	liblxc_so-caps.$(OBJEXT) liblxc_so-mainloop.$(OBJEXT) \
+	liblxc_so-af_unix.$(OBJEXT) liblxc_so-lxcutmp.$(OBJEXT) \
+	liblxc_so-lxclock.$(OBJEXT) liblxc_so-lxccontainer.$(OBJEXT) \
+	$(am__objects_3) $(am__objects_4) $(am__objects_5) \
+	$(am__objects_6) $(am__objects_7)
 liblxc_so_OBJECTS = $(am_liblxc_so_OBJECTS)
 am__DEPENDENCIES_1 =
 @ENABLE_CGMANAGER_TRUE@am__DEPENDENCIES_2 = $(am__DEPENDENCIES_1) \
@@ -374,7 +375,7 @@ am__can_run_installinfo = \
   esac
 am__noinst_HEADERS_DIST = arguments.h attach.h bdev.h caps.h cgroup.h \
 	conf.h console.h error.h list.h log.h lxc.h lxclock.h \
-	monitor.h namespace.h start.h state.h utils.h \
+	monitor.h namespace.h start.h state.h procfs.h utils.h \
 	../include/ifaddrs.h ../include/openpty.h \
 	../include/lxcmntent.h ../include/getline.h
 HEADERS = $(noinst_HEADERS) $(pkginclude_HEADERS)
@@ -567,22 +568,23 @@ pkginclude_HEADERS = \
 
 noinst_HEADERS = arguments.h attach.h bdev.h caps.h cgroup.h conf.h \
 	console.h error.h list.h log.h lxc.h lxclock.h monitor.h \
-	namespace.h start.h state.h utils.h $(am__append_1) \
+	namespace.h start.h state.h procfs.h utils.h $(am__append_1) \
 	$(am__append_2)
 sodir = $(libdir)
 LSM_SOURCES = lsm/nop.c lsm/lsm.h lsm/lsm.c $(am__append_3) \
 	$(am__append_4)
 liblxc_so_SOURCES = arguments.c arguments.h bdev.c bdev.h commands.c \
-	commands.h start.c start.h execute.c monitor.c monitor.h \
-	console.c freezer.c error.h error.c parse.c parse.h cgfs.c \
-	cgroup.c cgroup.h lxc.h utils.c utils.h sync.c sync.h \
-	namespace.h namespace.c conf.c conf.h confile.c confile.h \
-	list.h state.c state.h log.c log.h attach.c attach.h network.c \
-	network.h nl.c nl.h rtnl.c rtnl.h genl.c genl.h caps.c caps.h \
-	lxcseccomp.h mainloop.c mainloop.h af_unix.c af_unix.h \
-	lxcutmp.c lxcutmp.h lxclock.h lxclock.c lxccontainer.c \
-	lxccontainer.h version.h $(LSM_SOURCES) $(am__append_5) \
-	$(am__append_6) $(am__append_7) $(am__append_13)
+	commands.h start.c start.h procfs.c procfs.h execute.c \
+	monitor.c monitor.h console.c freezer.c error.h error.c \
+	parse.c parse.h cgfs.c cgroup.c cgroup.h lxc.h utils.c utils.h \
+	sync.c sync.h namespace.h namespace.c conf.c conf.h confile.c \
+	confile.h list.h state.c state.h log.c log.h attach.c attach.h \
+	network.c network.h nl.c nl.h rtnl.c rtnl.h genl.c genl.h \
+	caps.c caps.h lxcseccomp.h mainloop.c mainloop.h af_unix.c \
+	af_unix.h lxcutmp.c lxcutmp.h lxclock.h lxclock.c \
+	lxccontainer.c lxccontainer.h version.h $(LSM_SOURCES) \
+	$(am__append_5) $(am__append_6) $(am__append_7) \
+	$(am__append_13)
 AM_CFLAGS = -I$(top_srcdir)/src -DLXCROOTFSMOUNT=\"$(LXCROOTFSMOUNT)\" \
 	-DLXCPATH=\"$(LXCPATH)\" \
 	-DLXC_GLOBAL_CONF=\"$(LXC_GLOBAL_CONF)\" \
@@ -596,14 +598,16 @@ AM_CFLAGS = -I$(top_srcdir)/src -DLXCROOTFSMOUNT=\"$(LXCROOTFSMOUNT)\" \
 	-DRUNTIME_PATH=\"$(RUNTIME_PATH)\" -DSBINDIR=\"$(SBINDIR)\" \
 	$(am__append_8) $(am__append_9) $(am__append_10) \
 	$(am__append_11) $(am__append_12)
-liblxc_so_CFLAGS = -fPIC -DPIC $(AM_CFLAGS) -pthread $(am__append_15)
+liblxc_so_CFLAGS = -fPIC -DPIC $(AM_CFLAGS) -pthread \
+	-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=27 $(am__append_15)
 liblxc_so_LDFLAGS = \
 	-pthread \
 	-shared \
+	-rdynamic \
 	-Wl,-soname,liblxc.so.$(firstword $(subst ., ,$(VERSION)))
 
 liblxc_so_LDADD = $(CAP_LIBS) $(APPARMOR_LIBS) $(SELINUX_LIBS) \
-	$(SECCOMP_LIBS) $(am__append_14)
+	$(SECCOMP_LIBS) -lfuse $(am__append_14)
 bin_SCRIPTS = lxc-checkconfig $(am__append_16) $(am__append_17) \
 	$(am__append_18)
 EXTRA_DIST = \
@@ -1041,6 +1045,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-network.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-nl.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-parse.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-procfs.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-rtnl.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-seccomp.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/liblxc_so-start.Po@am__quote@
@@ -1147,6 +1152,20 @@ liblxc_so-start.obj: start.c
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -c -o liblxc_so-start.obj `if test -f 'start.c'; then $(CYGPATH_W) 'start.c'; else $(CYGPATH_W) '$(srcdir)/start.c'; fi`
 
+liblxc_so-procfs.o: procfs.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -MT liblxc_so-procfs.o -MD -MP -MF $(DEPDIR)/liblxc_so-procfs.Tpo -c -o liblxc_so-procfs.o `test -f 'procfs.c' || echo '$(srcdir)/'`procfs.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/liblxc_so-procfs.Tpo $(DEPDIR)/liblxc_so-procfs.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='procfs.c' object='liblxc_so-procfs.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -c -o liblxc_so-procfs.o `test -f 'procfs.c' || echo '$(srcdir)/'`procfs.c
+
+liblxc_so-procfs.obj: procfs.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -MT liblxc_so-procfs.obj -MD -MP -MF $(DEPDIR)/liblxc_so-procfs.Tpo -c -o liblxc_so-procfs.obj `if test -f 'procfs.c'; then $(CYGPATH_W) 'procfs.c'; else $(CYGPATH_W) '$(srcdir)/procfs.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/liblxc_so-procfs.Tpo $(DEPDIR)/liblxc_so-procfs.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='procfs.c' object='liblxc_so-procfs.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -c -o liblxc_so-procfs.obj `if test -f 'procfs.c'; then $(CYGPATH_W) 'procfs.c'; else $(CYGPATH_W) '$(srcdir)/procfs.c'; fi`
+
 liblxc_so-execute.o: execute.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(liblxc_so_CFLAGS) $(CFLAGS) -MT liblxc_so-execute.o -MD -MP -MF $(DEPDIR)/liblxc_so-execute.Tpo -c -o liblxc_so-execute.o `test -f 'execute.c' || echo '$(srcdir)/'`execute.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/liblxc_so-execute.Tpo $(DEPDIR)/liblxc_so-execute.Po
diff --git a/src/lxc/cgfs.c b/src/lxc/cgfs.c
index 796b220..26ca283 100644
--- a/src/lxc/cgfs.c
+++ b/src/lxc/cgfs.c
@@ -2319,6 +2319,15 @@ static const char *cgfs_get_cgroup(void *hdata, const char *subsystem)
 	return lxc_cgroup_get_hierarchy_path_data(subsystem, d);
 }
 
+static const char *cgfs_get_abs_cgroup(void *hdata, const char *subsystem)
+{
+	struct cgfs_data *d = hdata;
+
+	if (!d)
+		return NULL;
+	return lxc_cgroup_get_hierarchy_abs_path_data(subsystem, d);
+}
+
 static bool cgfs_unfreeze(void *hdata)
 {
 	struct cgfs_data *d = hdata;
@@ -2383,6 +2392,7 @@ static struct cgroup_ops cgfs_ops = {
 	.enter = cgfs_enter,
 	.create_legacy = cgfs_create_legacy,
 	.get_cgroup = cgfs_get_cgroup,
+	.get_abs_cgroup = cgfs_get_abs_cgroup,
 	.get = lxc_cgroupfs_get,
 	.set = lxc_cgroupfs_set,
 	.unfreeze = cgfs_unfreeze,
diff --git a/src/lxc/cgmanager.c b/src/lxc/cgmanager.c
index c4f48e9..2bb7aee 100644
--- a/src/lxc/cgmanager.c
+++ b/src/lxc/cgmanager.c
@@ -1234,6 +1234,7 @@ static struct cgroup_ops cgmanager_ops = {
 	.enter = cgm_enter,
 	.create_legacy = NULL,
 	.get_cgroup = cgm_get_cgroup,
+	.get_abs_cgroup = NULL,
 	.get = cgm_get,
 	.set = cgm_set,
 	.unfreeze = cgm_unfreeze,
diff --git a/src/lxc/cgroup.c b/src/lxc/cgroup.c
index 63a2ad4..52587cd 100644
--- a/src/lxc/cgroup.c
+++ b/src/lxc/cgroup.c
@@ -106,6 +106,13 @@ const char *cgroup_get_cgroup(struct lxc_handler *handler, const char *subsystem
 	return NULL;
 }
 
+const char *cgroup_get_abs_cgroup(struct lxc_handler *handler, const char *subsystem)
+{
+	if (ops)
+		return ops->get_abs_cgroup(handler->cgroup_data, subsystem);
+	return NULL;
+}
+
 bool cgroup_unfreeze(struct lxc_handler *handler)
 {
 	if (ops)
diff --git a/src/lxc/cgroup.h b/src/lxc/cgroup.h
index 7e03370..5a14335 100644
--- a/src/lxc/cgroup.h
+++ b/src/lxc/cgroup.h
@@ -41,6 +41,7 @@ struct cgroup_ops {
 	bool (*enter)(void *hdata, pid_t pid);
 	bool (*create_legacy)(void *hdata, pid_t pid);
 	const char *(*get_cgroup)(void *hdata, const char *subsystem);
+	const char *(*get_abs_cgroup)(void *hdata, const char* subsystem);
 	int (*set)(const char *filename, const char *value, const char *name, const char *lxcpath);
 	int (*get)(const char *filename, char *value, size_t len, const char *name, const char *lxcpath);
 	bool (*unfreeze)(void *hdata);
@@ -64,6 +65,7 @@ extern void cgroup_cleanup(struct lxc_handler *handler);
 extern bool cgroup_create_legacy(struct lxc_handler *handler);
 extern int cgroup_nrtasks(struct lxc_handler *handler);
 extern const char *cgroup_get_cgroup(struct lxc_handler *handler, const char *subsystem);
+extern const char *cgroup_get_abs_cgroup(struct lxc_handler *handler, const char *subsystem);
 extern bool cgroup_unfreeze(struct lxc_handler *handler);
 extern void cgroup_disconnect(void);
 
diff --git a/src/lxc/conf.c b/src/lxc/conf.c
index 6882076..18d033f 100644
--- a/src/lxc/conf.c
+++ b/src/lxc/conf.c
@@ -85,6 +85,7 @@
 #endif
 
 #include "lxcseccomp.h"
+#include "procfs.h"
 
 lxc_log_define(lxc_conf, lxc);
 
@@ -2170,6 +2171,35 @@ static int setup_mount(const struct lxc_rootfs *rootfs, const char *fstab,
 	return ret;
 }
 
+static int setup_procfs(const char *name, struct lxc_conf *lxc_conf) {
+    char srcaddr[MAXPATHLEN];
+    char dstaddr[MAXPATHLEN];
+    int i, fd;  
+    int res = 0;
+    struct mirror_ops *ops;
+    ENTRY *entry;
+
+    for (i = 0; i < lxc_conf->pfs_entries; i++) {
+        entry = lxc_conf->pfs_entry;
+        entry += i;
+        ops = entry->data;
+        snprintf(dstaddr, sizeof(dstaddr), "%s/proc/%s", lxc_conf->rootfs.mount, ops->name);
+        snprintf(srcaddr, sizeof(srcaddr), "%s/%s", lxc_conf->procfs, ops->name);
+
+        res = mount(srcaddr, dstaddr, "ext4", MS_MGC_VAL | MS_BIND, NULL);
+        if (res != 0) {
+            fprintf(stderr, "mount %s failed err=%s\n", srcaddr, strerror(errno));
+            res = -1;
+            break;  
+        }
+        fd = open(dstaddr, O_RDONLY);
+	if(fd < 0){
+        }
+    }
+
+    return res;
+}
+
 static int setup_mount_entries(const struct lxc_rootfs *rootfs, struct lxc_list *mount,
 	const char *lxc_name)
 {
@@ -3983,6 +4013,13 @@ int lxc_setup(struct lxc_handler *handler)
 		return -1;
 	}
 
+	if (lxc_conf->procfs != NULL) { 
+		if (setup_procfs(name, lxc_conf)) {
+			ERROR("failed to setup procfs for '%s'", name);
+			return -1;
+		}
+	}
+
 	if (!lxc_list_empty(&lxc_conf->mount_list) && setup_mount_entries(&lxc_conf->rootfs, &lxc_conf->mount_list, name)) {
 		ERROR("failed to setup the mount entries for '%s'", name);
 		return -1;
diff --git a/src/lxc/conf.h b/src/lxc/conf.h
index 8823dc1..d0533d8 100644
--- a/src/lxc/conf.h
+++ b/src/lxc/conf.h
@@ -302,6 +302,10 @@ struct lxc_conf {
 	struct lxc_tty_info tty_info;
 	struct lxc_console console;
 	struct lxc_rootfs rootfs;
+	char *procfs;  
+	char *pfslcrso;  
+	void *pfs_entry;  
+	int pfs_entries; 
 	char *ttydir;
 	int close_all_fds;
 	struct lxc_list hooks[NUM_LXC_HOOKS];
diff --git a/src/lxc/confile.c b/src/lxc/confile.c
index e678e4b..f768581 100644
--- a/src/lxc/confile.c
+++ b/src/lxc/confile.c
@@ -96,6 +96,8 @@ static int config_haltsignal(const char *, const char *, struct lxc_conf *);
 static int config_stopsignal(const char *, const char *, struct lxc_conf *);
 static int config_start(const char *, const char *, struct lxc_conf *);
 static int config_group(const char *, const char *, struct lxc_conf *);
+static int config_procfs(const char *, const char *, struct lxc_conf *);
+static int config_pfslcrso(const char *, const char *, struct lxc_conf *);
 
 static struct lxc_config_t config[] = {
 
@@ -152,6 +154,8 @@ static struct lxc_config_t config[] = {
 	{ "lxc.start.delay",          config_start                },
 	{ "lxc.start.order",          config_start                },
 	{ "lxc.group",                config_group                },
+	{ "lxc.procfs",               config_procfs               },
+	{ "lxc.pfslcrso",             config_pfslcrso             },
 };
 
 struct signame {
@@ -2415,3 +2419,11 @@ void write_config(FILE *fout, struct lxc_conf *c)
 	lxc_list_for_each(it, &c->groups)
 		fprintf(fout, "lxc.group = %s\n", (char *)it->elem);
 }
+
+static int config_procfs(const char *key, const char *value, struct lxc_conf *lxc_conf) {  
+    return config_path_item(&lxc_conf->procfs, value);  
+}
+
+static int config_pfslcrso(const char *key, const char *value, struct lxc_conf *lxc_conf) {  
+    return config_path_item(&lxc_conf->pfslcrso, value);  
+} 
diff --git a/src/lxc/procfs.c b/src/lxc/procfs.c
new file mode 100644
index 0000000..3420453
--- /dev/null
+++ b/src/lxc/procfs.c
@@ -0,0 +1,855 @@
+/*
+ * Copyright (c) 2009 Daniel Lezcano <daniel.lezcano@free.fr>
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * Author : Daniel Lezcano <daniel.lezcano@free.fr>
+ *
+ * ---
+ * fuse procfs proxy:
+ *
+ * The following program allows to overlap the /proc directory in
+ * order to hide or modify content to be showed to the user.
+ *
+ * Definitions:
+ *  - a file/directory showed as it is in the real /proc is a 'proxy'
+ *  - a file/directory hidden from the initial /proc is a 'shadow'
+ *  - a file/directory changed from the initial /proc is a 'mirror'
+ *
+ * At the init time, we did not bind mounted the old /proc, so we grab
+ * a reference on it and use the openat, opendirat, etc ... to relatively
+ * work with the old /proc directory
+ *
+ * When one of the ops is called (eg. open), we check if the file is
+ * hidden, otherwise we check if it is mirrored, otherwise we call the
+ * real file function syscall (here open).
+ *
+ * This program is intented to be extended ...
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <libgen.h>
+#include <errno.h>
+#include <dirent.h>
+#include <mntent.h>
+#include <limits.h>
+#include <fcntl.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/param.h>
+#include <glob.h>
+#include <dlfcn.h>
+#include <unistd.h>
+#include <search.h>
+#include <unistd.h>
+#include <sys/wait.h>
+#include <fnmatch.h>
+
+#include <fuse.h>
+#include "procfs.h"
+#include "cgroup.h"
+#include "list.h"
+
+enum {
+	PROCFS_PROXY,
+	PROCFS_MIRROR,
+};
+
+/*
+ * mirror_ops : file operations to be used for hooking the file content on /proc
+ */
+//extern char cgroup_lxc_path[MAXPATHLEN]__attribute__((weak));
+
+static const char *path_list[128];
+static unsigned int path_list_entries = 0;
+static char cpus_value[128];
+static struct lxc_handler *s_handler;
+
+static ENTRY shadow_entries[] = {
+	{ "sys", NULL },
+};
+
+struct mirror_ops *mirror_ops;
+static char cname[MAXPATHLEN];
+
+#define ARRAY_SIZE(t) (sizeof(t) / sizeof(t[0]))
+#define SHADOW_HASH_SIZE 32
+#define MIRROR_HASH_SIZE 32
+
+// struct to hold cached munged copy of /proc/cpuinfo
+
+// struct to hold cached munged copy of /proc/stat
+// 
+
+// prototypes are generated by the makefile
+//#include "procfs.proto.h"
+
+#if 0
+
+
+#endif
+//static struct mirror_ops meminfo_ops;
+//static struct mirror_ops stat_ops;
+
+/*
+ * Statically define the list of the entries we want to mirror
+ */
+static ENTRY *mirror_entry;
+static int mirror_entries;
+// = {
+//	{ "meminfo", &meminfo_ops },
+//        { "stat",    &stat_ops    },
+//};
+
+
+/*
+ * a simple wrapper function to find an entry in the hash
+ */
+ENTRY *hash_find(char *key, struct hsearch_data *hash)
+{
+	ENTRY entry, *pentry;
+
+	entry.key = key;
+
+	hsearch_r(entry, FIND, &pentry, hash);
+
+	return pentry;
+}
+
+/*** fuse ops definitions ***/
+
+static int procfs_readlink(const char *path, char *buf, size_t bufsiz)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+	char *bname = strchr(path, '/');
+	int ret;
+
+	if (strcmp(path, "/"))
+		bname += 1;
+
+	ret = readlinkat(dirfd(fsinfo->procdir), bname, buf, bufsiz);
+	if (ret < 0)
+		return -errno;
+
+	buf[ret] = '\0';
+
+	return 0;
+}
+
+static int procfs_refresh_cpumask (struct procfs_info *fsinfo)
+{
+//     char cgpath[MAXPATHLEN];
+     int ret = 0;
+	 int index = 0;
+
+     // build up the bitmask of what cpus we are allowed to see. 
+     // need to parse the format of cpuset.cpus.
+     // if cpuset.cpus is longer than 255 characters, we'll miss some. 
+        
+     memset (fsinfo->cpumask, 0, 1024);
+
+     // parse cpu string. e.g. 1,3,5-10,12,15-23 
+     {
+	     char in_range;
+	     int c,done,i,j,k;
+	     int start_range;
+	     char number[10];
+	     
+	     done=0;
+	     i=0;
+	     in_range=0;
+	     start_range=0;
+	     
+         memset(number, 0, 10);
+	     
+	     while (!done){
+		  c = cpus_value[index];
+		  switch (c){
+		  case '0' ... '9':
+		       number[i++] = c;
+		       break;
+		  case 0:
+		       done=1;
+//		       break;
+		  case '\n':
+		  case ',':
+		       i=0;
+		       j=atoi(number);
+		       if (in_range){
+					for (k=start_range;k<=j;k++){
+						fsinfo->cpumask[k]=1;
+					}
+		       } else {
+			 		fsinfo->cpumask[j]=1;
+		       }
+		       memset(number,0,10);
+		       in_range=0;
+		       break;
+		  case '-':
+		       i=0;
+		       j=atoi(number);
+		       memset(number,0,10);
+		       start_range=j;
+		       in_range=1;
+		       break;
+		  default:
+		       i=0;
+		       in_range=0;
+		  }
+			++index;
+	     }
+     }// parser
+
+     return ret;     
+}
+
+static int procfs_getattr(const char *path, struct stat *stbuf)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+
+        char *bname = strchr(path, '/');
+//	struct mirror_ops *ops;
+//	ENTRY *entry;
+
+	if (strcmp(path, "/"))
+		bname += 1;
+
+ 	if (hash_find(bname, &fsinfo->shadow_hash))
+ 		return -ENOENT;
+
+	if (fstatat(dirfd(fsinfo->procdir), bname, stbuf, AT_SYMLINK_NOFOLLOW))
+ 		return -errno;
+   
+        // we have a problem. fuse seems to use this call to decide how much data to 
+	// return to the user. however stbuf->st_size == 0 for most proc files. 
+	// The farmers method could over or underestimate the size of the file given
+	// that /proc files are dynamic.
+        
+        // do this just for mirrored files.
+        if (hash_find(bname, &fsinfo->mirror_hash)) stbuf->st_size=getattr_size(path);
+   
+	return 0;
+}
+
+static int procfs_open(const char *path, struct fuse_file_info *fi)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+	struct procfs_file *pfile;
+	char *bname = strchr(path, '/');
+	ENTRY *entry;
+
+	if (strcmp(path, "/"))
+		bname += 1;
+
+	/* this path is hidden */
+ 	if (hash_find(bname, &fsinfo->shadow_hash))
+ 		return -ENOENT;
+
+	pfile = malloc(sizeof(*pfile));
+	if (!pfile)
+		return -ENOMEM;
+    memset(pfile, 0, sizeof(*pfile));
+
+	fi->fh = (typeof(fi->fh))pfile;
+
+	/* this path must be mirrored */
+	entry = hash_find(bname, &fsinfo->mirror_hash);
+    if (entry) {
+        pfile->type = PROCFS_MIRROR;
+        pfile->file.mirror.ops = entry->data;
+        pfile->file.mirror.fd = openat(dirfd(fsinfo->procdir), bname, fi->flags);
+        if (pfile->file.mirror.fd < 0) {
+            free(pfile);
+            return -errno;
+        }
+
+        if (pfile->file.mirror.ops->open)
+            return pfile->file.mirror.ops->open(path, fi);
+    }
+
+	/* default we proxy the file */
+	pfile->type = PROCFS_PROXY;
+	pfile->file.proxy.fd = openat(dirfd(fsinfo->procdir), bname, fi->flags);
+	if (pfile->file.proxy.fd < 0) {
+		free(pfile);
+		return -errno;
+	}
+
+	return 0;
+}
+
+static int procfs_read(const char *path, char *buf, size_t size,
+		      off_t offset, struct fuse_file_info *fi)
+{
+	int ret;
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;
+
+	if (!offset)
+		lseek(pfile->file.proxy.fd, 0, SEEK_SET);
+
+    switch (pfile->type) {
+        case PROCFS_MIRROR:
+            ret = pfile->file.mirror.ops->read(path, buf, size, offset, fi);
+            break;
+        case PROCFS_PROXY:
+            ret = read(pfile->file.proxy.fd, buf, size);
+            if (ret < 0)
+                return -errno;
+            break;
+        default:
+            ret = -EIO;
+    }
+
+	return ret;
+}
+
+static int procfs_write(const char *path, const char *buf, size_t size,
+		       off_t offset, struct fuse_file_info *fi)
+{
+	int ret;
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;;
+
+	if (!offset)
+		lseek(pfile->file.proxy.fd, 0, SEEK_SET);
+
+	switch (pfile->type) {
+
+	case PROCFS_MIRROR:
+		ret = pfile->file.mirror.ops->write(path, buf, size, offset, fi);
+		break;
+
+	case PROCFS_PROXY:
+		ret = write(pfile->file.proxy.fd, buf, size);
+		if (ret < 0)
+			return -errno;
+		break;
+	default:
+		ret = -EIO;
+	}
+
+	return ret;
+}
+
+static int procfs_release(const char *path, struct fuse_file_info *fi)
+{
+	struct procfs_file *pfile = (typeof(pfile))fi->fh;;
+	int ret = 0;
+
+	switch (pfile->type) {
+
+	case PROCFS_MIRROR:
+		ret = pfile->file.mirror.ops->release(path, fi);
+		if (close(pfile->file.mirror.fd))
+			ret = -errno;
+		break;
+	case PROCFS_PROXY:
+		if (close(pfile->file.proxy.fd))
+			ret = -errno;
+		break;
+	default:
+		ret = -EIO;
+	}
+
+	free(pfile);
+
+	return ret;
+}
+
+static int procfs_opendir(const char *path, struct fuse_file_info *fi)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+	char *bname;
+	int fd;
+
+	if (!strcmp(path, "/")) {
+		fsinfo->subdir = fsinfo->procdir;
+		return 0;
+	}
+
+	bname = strchr(path, '/') + 1;
+
+	if (hash_find(bname, &fsinfo->shadow_hash))
+		return -ENOENT;
+
+	fd = openat(dirfd(fsinfo->procdir), bname, O_DIRECTORY);
+	if (fd < 0)
+		return -errno;
+
+	fsinfo->subdir = fdopendir(fd);
+
+	return 0;
+}
+
+static int procfs_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
+			 off_t offset, struct fuse_file_info *fi)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+        struct dirent dirent, *direntp;
+
+	if (!offset)
+		rewinddir(fsinfo->subdir);
+
+        while (!readdir_r(fsinfo->subdir, &dirent, &direntp) && direntp) {
+
+		if (hash_find(direntp->d_name, &fsinfo->shadow_hash))
+			continue;
+
+		if (filler(buf, direntp->d_name, NULL, offset++))
+			break;
+	}
+
+	return 0;
+}
+
+static int procfs_releasedir(const char *path, struct fuse_file_info *fi)
+{
+	struct fuse_context *context = fuse_get_context();
+	struct procfs_info *fsinfo = context->private_data;
+	DIR *subdir = fsinfo->subdir;
+
+	fsinfo->subdir = NULL;
+	if (subdir && subdir != fsinfo->procdir)
+		closedir(subdir);
+
+	return 0;
+}
+
+static int procfs_init_hash(struct hsearch_data *hash, size_t hash_size,
+			    ENTRY entries[], size_t entries_size)
+{
+	int i;
+	ENTRY *pentry;
+
+	memset(hash, 0, sizeof(*hash));
+
+	if (!hcreate_r(hash_size, hash))
+		return -1;
+
+	for (i = 0; i < entries_size; i++)
+		if (!hsearch_r(entries[i], ENTER, &pentry, hash))
+			return -1;
+
+	return 0;
+}
+
+static void *procfs_init(struct fuse_conn_info *conn)
+{
+	struct procfs_info *fsinfo;
+
+	fsinfo = malloc(sizeof(*fsinfo));
+	if (!fsinfo)
+		return NULL;
+    memset(fsinfo, 0, sizeof(*fsinfo));
+
+	fsinfo->procdir = opendir("/proc");
+	if (!fsinfo->procdir)
+		goto out_free_fsinfo;
+
+	fsinfo->subdir = NULL;
+
+	if (procfs_init_hash(&fsinfo->shadow_hash, SHADOW_HASH_SIZE,
+			     shadow_entries, ARRAY_SIZE(shadow_entries)))
+		goto out_free_fsinfo;
+
+	if (procfs_init_hash(&fsinfo->mirror_hash, MIRROR_HASH_SIZE,
+			     mirror_entry, mirror_entries))
+		goto out_destroy_shadow_hash;
+    
+	if (cpus_value[0] == 0) 
+		memset (fsinfo->cpumask, 1, 1024);
+	else 
+		procfs_refresh_cpumask(fsinfo);
+
+out:
+	return fsinfo;
+
+out_destroy_shadow_hash:
+	hdestroy_r(&fsinfo->shadow_hash);
+out_free_fsinfo:
+	free(fsinfo);
+	fsinfo = NULL;
+	goto out;
+}
+
+static void procfs_destroy(void *private_data)
+{
+	struct procfs_info *fsinfo = private_data;
+
+	closedir(fsinfo->procdir);
+	hdestroy_r(&fsinfo->shadow_hash);
+	hdestroy_r(&fsinfo->mirror_hash);
+	free(fsinfo);
+    free((void*)mirror_entry);
+}
+
+static int procfs_flush(const char *name, struct fuse_file_info *fi)
+{
+   return 0;
+}
+
+
+static struct fuse_operations procfs_ops = {
+	.readlink   = procfs_readlink,
+	.getattr    = procfs_getattr,
+	.open       = procfs_open,
+	.read       = procfs_read,
+	.write      = procfs_write,
+	.opendir    = procfs_opendir,
+	.releasedir = procfs_releasedir,
+	.readdir    = procfs_readdir,
+	.release    = procfs_release,
+ 	.init       = procfs_init,
+ 	.destroy    = procfs_destroy,
+        .flush      = procfs_flush,
+};
+
+static int pathlist_select (const struct dirent *dirent) {
+	if (fnmatch ("*.conf", dirent->d_name, 0) == 0) {
+		return (1);
+	}
+
+	return (0);
+}
+
+static void defaults_path_build (void) {
+	char cwd[1024];
+	char *res;
+
+	path_list[path_list_entries++] = "/usr/lib64/";
+	path_list[path_list_entries++] = "/usr/lib/";
+	path_list[path_list_entries++] = "/usr/local/lib/";
+	path_list[path_list_entries++] = "/usr/local/lib/lcrso/";
+
+	res = getcwd (cwd, sizeof (cwd));
+	if (res != NULL && (path_list[path_list_entries++] = strdup (cwd)) != NULL) {
+		path_list_entries++;
+	}
+
+}
+
+static void ld_library_path_build (void) {
+	char *ld_library_path;
+	char *my_ld_library_path;
+	char *p_s, *ptrptr;
+
+	ld_library_path = getenv ("LD_LIBRARY_PATH");
+	if (ld_library_path == NULL) {
+		return;
+	}
+	my_ld_library_path = strdup (ld_library_path);
+	if (my_ld_library_path == NULL) {
+		return;
+	}
+
+	p_s = strtok_r (my_ld_library_path, ":", &ptrptr);
+	while (p_s != NULL) {
+		char *p = strdup (p_s);
+		if (p && path_list_entries < 128) {
+			path_list[path_list_entries++] = p;
+		}
+		p_s = strtok_r (NULL, ":", &ptrptr);
+	}
+
+	free (my_ld_library_path);
+}
+
+static int ldso_path_build (const char *path, const char *filename) {
+	FILE *fp;
+	char string[1024];
+	char filename_cat[1024];
+	char newpath[1024];
+	char *newpath_tmp;
+	char *new_filename;
+	int j;
+	struct dirent **scandir_list;
+	unsigned int scandir_entries;
+
+	snprintf (filename_cat, sizeof(filename_cat), "%s/%s", path, filename);
+	if (filename[0] == '*') {
+		scandir_entries = scandir (
+			path,
+			&scandir_list,
+			pathlist_select, alphasort);
+		if (scandir_entries == 0) {
+			return 0;
+		} else if (scandir_entries == -1) {
+			return -1;
+		} else {
+			for (j = 0; j < scandir_entries; j++) {
+				ldso_path_build (path, scandir_list[j]->d_name);
+			}
+		}
+	}
+
+	fp = fopen (filename_cat, "r");
+	if (fp == NULL) {
+		return (-1);
+	}
+
+	while (fgets (string, sizeof (string), fp)) {
+		char *p;
+		if (strlen(string) > 0)
+			string[strlen(string) - 1] = '\0';
+		if (strncmp (string, "include", strlen ("include")) == 0) {
+			newpath_tmp = string + strlen ("include") + 1;
+			for (j = strlen (string);
+				string[j] != ' ' &&
+					string[j] != '/' &&
+					j > 0;
+				j--) {
+			}
+			string[j] = '\0';
+			new_filename = &string[j] + 1;
+			strcpy (newpath, path);
+			strcat (newpath, "/");
+			strcat (newpath, newpath_tmp);
+			ldso_path_build (newpath, new_filename);
+			continue;
+		}
+		p = strdup (string);
+		if (p && path_list_entries < 128) {
+			path_list[path_list_entries++] = p;
+		}
+	}
+	fclose(fp);
+	return (0);
+}
+
+int procfs_mount(const char *name, const char *libpath, 
+        int argc, char **argv, 
+        void **pfs_entry, int *pfs_entries, 
+        char *value, struct lxc_handler *handler)
+{
+	int i = 0, res;	
+	glob_t glob_res;	
+	void *handle;
+	char pattern[MAXPATHLEN];
+	int status;
+	pid_t pid;
+	const char *p = libpath;
+	char cgpath[MAXPATHLEN];
+	char *ptr = NULL;
+	char tail[12];
+
+	s_handler = handler;
+
+	if (value != NULL)
+		strncpy(cpus_value, value, sizeof(cpus_value));		
+
+	while (1) {
+		if (i)
+			snprintf(tail, 12, "-%d", i);
+		else
+			*tail = '\0';
+		snprintf(cgpath, sizeof(cgpath), "/lxc/%s%s", name, tail);
+		
+		//cgroup_path_get(&ptr, "memory", cgpath);
+				
+		if (access(ptr, F_OK) == 0) {
+			i++;
+			continue;
+		}
+		break;
+	}
+
+	snprintf(cname, sizeof(cname), "%s%s", name, tail);
+//	strncpy(cname, name, sizeof(cname));
+
+	if (libpath == NULL) {
+		defaults_path_build();
+		ld_library_path_build();
+		ldso_path_build("/etc", "ld.so.conf");
+		for (i = 0; i < path_list_entries; i++) {
+			snprintf(pattern, sizeof(pattern), "%s/lcrso", path_list[i]);
+			if (access(pattern, F_OK) == 0) {
+				p = path_list[i];
+				break;
+			}
+		}	
+	} else 
+		strncpy(pattern, p, sizeof(pattern));	
+
+	strncat(pattern, "/*.lcrso", sizeof(pattern));
+
+	res = glob(pattern, 0, NULL, &glob_res);
+	if (res < 0) {
+		return res;
+	}
+		
+	for (i = 0; i < glob_res.gl_pathc; i++) {
+		handle = dlopen(glob_res.gl_pathv[i], RTLD_NOW);
+		if (handle == NULL) {
+			fprintf(stderr, "dlopen %s err: %s\n", glob_res.gl_pathv[i], dlerror());
+			continue;
+		}
+		
+		if (mirror_ops == NULL)
+			continue;
+		if (mirror_ops->name == NULL) 
+			continue;
+			
+		mirror_entry = realloc(mirror_entry, (1 + mirror_entries) * sizeof(ENTRY));
+		
+		mirror_entry[mirror_entries].key = mirror_ops->name;
+		mirror_entry[mirror_entries].data = mirror_ops;
+	
+		++mirror_entries;
+		mirror_ops = NULL;
+	}
+	*pfs_entry = mirror_entry;
+	*pfs_entries = mirror_entries;
+		
+	globfree(&glob_res);
+	fflush(NULL);
+	if ((pid = fork()) == 0) {
+		res = fuse_main(argc, argv, &procfs_ops, NULL);
+		exit(res);
+	} else {
+		waitpid(pid, &status, 0);
+		if (status != 0)
+			return status;
+	}
+
+	return 0;
+}
+
+/*
+ * Mirroring specific functions
+ */
+
+
+int get_cgroup_mount(const char *mtab, char *mnt)
+{
+        struct mntent *mntent;
+        FILE *file = NULL;
+        int err = -1;
+
+        file = setmntent(mtab, "r");
+        if (!file)
+                goto out;
+
+        while ((mntent = getmntent(file))) {
+
+		/* there is a cgroup mounted named "lxc" */
+		if (!strcmp(mntent->mnt_fsname, "lxc") &&
+		    !strcmp(mntent->mnt_type, "cgroup")) {
+			strcpy(mnt, mntent->mnt_dir);
+			err = 0;
+			break;
+		}
+
+		/* fallback to the first non-lxc cgroup found */
+                if (!strcmp(mntent->mnt_type, "cgroup") && err) {
+			strcpy(mnt, mntent->mnt_dir);
+			err = 0;
+		}
+        };
+
+        fclose(file);
+out:
+        return err;
+}
+
+char *cgroup_name(void)
+{
+    char *path = "/proc/self/cgroup", *name;
+    char line[MAXPATHLEN];
+    FILE *file;
+    int ret;
+
+    file = fopen(path, "r");
+    if (!file)
+        return NULL;
+    ret = fscanf(file, "%s", line);
+    fclose(file);
+    if (ret < 0){
+        return NULL;
+    }
+
+    strtok(line, ":");
+    strtok(NULL, ":");
+    name = strtok(NULL, ":");
+    // I want this to work with the root cgroup. 
+    //        name = strtok(name, "/");
+
+    return name ? strdup(name) : NULL;
+}
+
+off_t getattr_size(const char * path)
+{
+     // we have a problem. fuse seems to use the getattr call to decide how much data to 
+     // return to the user. however stbuf->st_size == 0 for most proc files. 
+     // The farmers method could over or underestimate the size of the file given
+     // that /proc files are dynamic.
+     struct fuse_context *context = fuse_get_context();
+     struct procfs_info *fsinfo = context->private_data;
+
+     char *bname = strchr(path,'/');
+     off_t size;
+     int fd;
+     
+     if (strcmp(path, "/"))  bname += 1;
+
+     size=0;
+
+     fd = openat(dirfd(fsinfo->procdir),bname, O_RDONLY);
+     if (fd > -1) {           
+	  // lseek won't work on many files in /proc
+	  // We follow what wc -c does, and try lseek, then the farmers method.
+	  // 
+	  char buf[4096];
+	  int t=4096, r=0;
+	  
+	  if ((r=lseek(fd,0,SEEK_END)) >=0) size=r; else 
+	  {
+	       while ( ( r=read(fd,buf,t)) > 0) 
+	       {
+		    size+=r;
+	       }
+	  } 
+	  close (fd);
+     }
+     return size;
+}
+
+void lcr_component_register(struct mirror_ops *ops) {
+	mirror_ops = ops; 	
+	const char *ptr =  NULL;
+
+	if (strcmp(ops->name, "meminfo") == 0) {
+		ptr = cgroup_get_abs_cgroup(s_handler, "memory");
+		if (ptr != NULL)
+			strcpy(ops->priv_data, ptr);
+	}
+	else if (strcmp(ops->name, "stat") == 0) {
+		ptr = cgroup_get_abs_cgroup(s_handler, "cpuacct");
+		if (ptr != NULL)
+			strcpy(ops->priv_data, ptr);
+		ptr =  NULL;
+		ptr = cgroup_get_abs_cgroup(s_handler, "cpuset");
+
+		if (ptr != NULL)
+			strcpy(ops->priv_data + 2000, ptr);
+
+
+	}
+	else if (strcmp(ops->name, "cpuinfo") == 0) {
+		ptr = cgroup_get_abs_cgroup(s_handler, "cpuset");
+		if (ptr != NULL)
+		{	
+			strcpy(ops->priv_data, ptr);
+		}	
+	}
+}
+
+
diff --git a/src/lxc/procfs.h b/src/lxc/procfs.h
new file mode 100644
index 0000000..a39e971
--- /dev/null
+++ b/src/lxc/procfs.h
@@ -0,0 +1,100 @@
+#ifndef _PROCFS_H_
+#define _PROCFS_H_
+
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS	64 
+#endif
+#ifndef FUSE_USE_VERSION
+#define FUSE_USE_VERSION	27
+#endif
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+
+#ifndef __USE_GNU
+#define __USE_GNU
+#endif
+#include </usr/include/search.h>
+#include <sys/types.h>
+#include <dirent.h>
+#include <time.h>
+#include <fuse.h>
+
+struct lxc_handler;
+/*
+ * Global structure when initialization fuse-procfs.
+ *  - procdir is the reference on the old /proc mounting point
+ *  - subdir is a working variable when walking on the dir tree
+ *  - shadow_hash contains the files/directory to be hidden
+ *  - mirror_hash contains the files to be mirrored with their ops
+ *  - cpumask[i] holds a 1 if the current container is allowed to see cpu number i.   
+ */
+struct procfs_info {
+     DIR *procdir;                  
+     DIR *subdir;
+     struct hsearch_data shadow_hash;
+     struct hsearch_data mirror_hash;
+     char cpumask[1024];
+     time_t cpumask_last_refresh_time;
+};
+
+/*
+ * descriptor for proxy file : when the file is opened, the descriptor is fd
+ * is stored in order to be reused in the read, write, etc ... functions
+ */
+struct proxy_file {
+	int fd;
+};
+
+/*
+ * descriptor for mirror : at the open time, the filename is checked against
+ * the mirror hash table and the corresponding ops are retrieved and stored
+ * in this structure
+ * 
+ * we also open the underlying in case we want to do a partial mirror.
+ * fixme: remove the union. It adds nothing. 
+ */
+struct mirror_file {
+        int fd; 
+	struct mirror_ops *ops;
+	void *data;
+};
+
+/*
+ * Statically define the list of the entries we want to hide
+ */
+
+/*
+ * General file descriptor wrapping all the information for each kind of file
+ * - type describes if it is a mirror or a proxy file
+ * - the union contains the information for the file
+ * - private_data contains something specific stored at open time
+ */
+struct procfs_file {
+	int type;
+	union {
+		struct proxy_file proxy;
+		struct mirror_file mirror;
+	} file;
+
+	void *private_data;
+};
+
+struct mirror_ops {
+	char *name;
+	int (*open)(const char *, struct fuse_file_info *);
+	int (*read)(const char *, char *, size_t, off_t, struct fuse_file_info *);
+	int (*write)(const char *, const char *, size_t, off_t, struct fuse_file_info *);
+	int (*release)(const char *, struct fuse_file_info *);
+	int (*seek)(const char *, struct fuse_file_info *);
+	void *priv_data;
+};
+
+off_t getattr_size(const char * path);
+char *cgroup_name(void);
+int get_cgroup_mount(const char *mtab, char *mnt);
+void lcr_component_register(struct mirror_ops *);
+void lcr_component_reregister(struct lxc_handler *handler);
+int procfs_mount(const char *name, const char *libpath, int argc, char **argv, void **pfs_entry, int *pfs_entries, char *value, struct lxc_handler *handler);
+
+#endif
diff --git a/src/lxc/start.c b/src/lxc/start.c
index e6b4895..fdaacc7 100644
--- a/src/lxc/start.c
+++ b/src/lxc/start.c
@@ -71,6 +71,7 @@
 #include "caps.h"
 #include "bdev.h"
 #include "lsm/lsm.h"
+#include "procfs.h"
 
 lxc_log_define(lxc_start, lxc);
 
@@ -786,10 +787,71 @@ static int lxc_spawn(struct lxc_handler *handler)
 
 	netpipe = -1;
 
+	//procfs
+	int pfs_argc = 6;
+	char *pfs_argv[6] = {"procfs", "-o", "direct_io", "-o", "allow_other"};  
+	char pfs_dir[MAXPATHLEN];  
+	struct lxc_list *it;  
+	char *cpus_value = NULL; 
+	struct lxc_conf *conf = NULL;
+	int err = -1;
+	conf = handler->conf;
+
+
+
 	for (i = 0; i < LXC_NS_MAX; i++)
 		if (handler->conf->inherit_ns_fd[i] != -1)
 			preserve_mask |= ns_info[i].clone_flag;
 
+	if (!cgroup_init(handler)) {
+		ERROR("failed initializing cgroup support");
+		goto out_delete_net;
+	}
+
+	cgroups_connected = true;
+
+	if (!cgroup_create(handler)) {
+		ERROR("failed creating cgroups");
+		goto out_delete_net;
+	}
+
+	lxc_list_for_each(it, &conf->cgroup) {
+		struct lxc_cgroup *cg = it->elem;
+		if (strcmp(cg->subsystem, "cpuset.cpus") == 0) {
+			cpus_value = cg->value;             
+			break;
+		}
+	}
+
+	pfs_dir[0] = 0; 
+	if (conf->procfs == NULL) {     
+		strncpy(pfs_dir,"/tmp/lxcXXXXXX", sizeof(pfs_dir));
+		close(mkstemp(pfs_dir));
+		unlink(pfs_dir);
+
+		if (mkdir_p(pfs_dir, 0755)) {
+			SYSERROR("failed to create tmpdir '%s'", pfs_dir);
+			return -1;
+		}
+		conf->procfs = pfs_dir;
+	}
+	else {
+		if (access(conf->procfs, F_OK)) {
+			if (mkdir_p(conf->procfs, 0755)) {
+				SYSERROR("failed to create tmpdir '%s'", pfs_dir);
+				return -1;  
+			}
+		}
+	}
+
+	pfs_argv[pfs_argc - 1] = conf->procfs;
+
+	err = procfs_mount(handler->name, conf->pfslcrso, pfs_argc, pfs_argv, &conf->pfs_entry, &conf->pfs_entries, cpus_value, handler);
+	if (err < 0) {
+		ERROR("failed to mount procfs path: %s\n", conf->procfs);
+		return err;
+	}
+
 	if (lxc_sync_init(handler))
 		return -1;
 
@@ -845,19 +907,6 @@ static int lxc_spawn(struct lxc_handler *handler)
 		INFO("Inheriting a UTS namespace");
 	}
 
-
-	if (!cgroup_init(handler)) {
-		ERROR("failed initializing cgroup support");
-		goto out_delete_net;
-	}
-
-	cgroups_connected = true;
-
-	if (!cgroup_create(handler)) {
-		ERROR("failed creating cgroups");
-		goto out_delete_net;
-	}
-
 	/*
 	 * if the rootfs is not a blockdev, prevent the container from
 	 * marking it readonly.
@@ -1127,6 +1176,15 @@ out_fini:
 	lxc_delete_network(handler);
 
 out_fini_nonet:
+	if (conf->procfs != NULL) { 
+		umount(conf->procfs);
+		err = system("sed -i '/fuse.procfs/d' /etc/mtab");
+	}
+
+	if (conf->procfs[0] != 0) {
+		rmdir(conf->procfs); 
+	}
+
 	lxc_fini(name, handler);
 	return err;
 
diff --git a/src/python-lxc/Makefile.in b/src/python-lxc/Makefile.in
index 867e97e..39f075e 100644
--- a/src/python-lxc/Makefile.in
+++ b/src/python-lxc/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/src/tests/Makefile.in b/src/tests/Makefile.in
index d2ecc77..31c721f 100644
--- a/src/tests/Makefile.in
+++ b/src/tests/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
diff --git a/templates/Makefile.in b/templates/Makefile.in
index 2902998..7ee6615 100644
--- a/templates/Makefile.in
+++ b/templates/Makefile.in
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.14.1 from Makefile.am.
+# Makefile.in generated by automake 1.13.4 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994-2013 Free Software Foundation, Inc.
